Type: Package
Package: HistogramTools
Title: Utility Functions for R Histograms
Version: 0.4.1
Date: 2026-05-06
Authors@R: c(
    person("Murray", "Stokely", , "murray@stokely.org", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0009-0008-3390-1338")),
    person(, "Google, Inc.", role = "cph"),
    person("Tim", "Hesterberg", , "rocket@google.com", role = "ctb")
  )
Maintainer: Murray Stokely <murray@stokely.org>
Description: Provides a number of utility functions useful for
    manipulating large histograms.  This includes methods to trim, subset,
    merge buckets, merge histograms, convert to CDF, and calculate
    information loss due to binning.  It also provides a protocol buffer
    representation of R's native histogram class to allow histograms over
    large data sets to be computed and combined in distributed analytical
    pipelines.  Implements bin-by-bin histogram distance measures
    described in Rubner, Tomasi and Guibas (2000)
    <doi:10.1023/A:1026543900054>, Swain and Ballard (1991)
    <doi:10.1007/BF00130487>, and Puzicha, Hofmann and Buhmann (1997)
    <doi:10.1109/CVPR.1997.609331>, and average shifted histograms as
    in Scott (2015, ISBN:9781118575536).
License: Apache License 2.0
URL: https://github.com/murraystokely/histogramtools
BugReports: https://github.com/murraystokely/histogramtools/issues
Imports: ash, Hmisc
Suggests: emdist, gdata, testthat (>= 3.0.0)
Enhances: RProtoBuf
Classification/ACM: G.3
Config/testthat/edition: 3
Copyright: Copyright 2011-2015 Google, Inc. Copyright 2026 Murray
        Stokely
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-05-06 18:16:42 UTC; murray
Author: Murray Stokely [aut, cre, cph] (ORCID:
    <https://orcid.org/0009-0008-3390-1338>),
  Google, Inc. [cph],
  Tim Hesterberg [ctb]
Repository: CRAN
Date/Publication: 2026-05-12 17:50:08 UTC
Built: R 4.6.0; ; 2026-05-12 19:54:13 UTC; unix

exportPattern("^[[:alpha:]]+")
importFrom(ash, ash1)
importFrom(Hmisc, wtd.quantile)
S3method(as.Message, histogram)
S3method(as.histogram, Message)
importFrom("graphics", "abline", "arrows", "axis", "plot", "rect")
importFrom("stats", "aggregate", "approxfun", "knots")
importFrom("utils", "head", "tail")
importFrom("stats", "weighted.mean")

## HistogramTools

<!-- badges: start -->

[![R-CMD-check](https://github.com/murraystokely/histogramtools/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/murraystokely/histogramtools/actions/workflows/R-CMD-check.yaml)
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/HistogramTools)](https://cran.r-project.org/package=HistogramTools)
[![Codecov test coverage](https://codecov.io/gh/murraystokely/histogramtools/graph/badge.svg)](https://app.codecov.io/gh/murraystokely/histogramtools)
<!-- badges: end -->

This package provides a number of utility functions useful for manipulating large histograms. This includes methods to trim, subset, merge buckets, merge histograms, convert to CDF, and calculate information loss due to binning. It also provides a protocol buffer representation of R's native histogram class to allow histograms over large data sets to be computed and combined in distributed analytical pipelines.

## Installation

You can either install from source via this repo, or install
[the CRAN package](https://cran.r-project.org/package=HistogramTools)
the usual way from [R](https://www.r-project.org).

## More Info

[RProtoBuf & HistogramTools: Statistical Analysis Tools for Large Data Sets](https://opensource.googleblog.com/2013/10/rprotobuf-histogramtools-statistical_10.html) Google Open Source Blog, October 10, 2013

## History

This package was originally developed at Google between 2011 and 2015.
It is now independently maintained by the original author.

## Authors

Murray Stokely

## License

Apache 2.0

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

KSDCC <- function(h) {
  # Kolmogorov-Smirnov Distance of the Cumulative Curves
  # (aka Maximum Displacement of the Cumulative Curves)
  #
  # Kolmogorov-Smirnov distance between the largest and smallest
  # empirical cumulative distribution functions that could be
  # represented by the binned data in the provided histogram.
  #
  # See e.g. http://research.microsoft.com/pubs/72885/fiveyearstudy.pdf
  #
  # Args:
  #   h:  An R histogram object.
  # Return Value:
  #   A number between 0 and 1 giving the MDCC.

  # Geometrically, we are looking at :
  #
  #   MinEcdf <- HistToEcdf(h, f=0)
  #   MaxEcdf <- HistToEcdf(h, f=1)
  #   return(max(MaxEcdf(h$mids) - MinEcdf(h$mids)))
  #
  # (The knots() of these ECDFs are our histogram break points.
  #  So we evaluate the differences at the histogram mid points.)

  stopifnot(inherits(h, "histogram"))
  # However, this is more succintly expressed as:
  return(max(h$counts) / sum(h$counts))
}

EMDCC <- function(h) {
  # Earth Mover's Distance of the Cumulative Curves
  #
  # The "Earth Mover's Distance" is like the Kolmogorov-Smirnof
  # statistic, but using an integral to capture the difference across all
  # points of the curve rather than just the maximum difference.  This is
  # also known as Mallows distance, or Wasserstein distance with p=1.
  #
  # We calculate this difference between the empirical cumulative
  # distribution functions of the largest and smallest possible data
  # sets that could be represented by the binned data in the provided
  # histogram.
  #
  # See e.g. http://en.wikipedia.org/wiki/Earth_mover's_distance
  #
  # Args:
  #   h:  An R histogram object.
  # Return Value:
  #   A number between 0 and 1 giving the EMDCC.

  # Geometrically, we are looking at :
  #
  #   MinEcdf <- HistToEcdf(h, f=0)
  #   MaxEcdf <- HistToEcdf(h, f=1)
  #   total.width <- max(knots(MaxEcdf)) - min(knots(MinEcdf))
  #   total.height <- 1
  #   total.area <- total.width * total.height
  #
  #   areas.of.cdf.uncertainty <- (tail(knots(MinEcdf), -1) -
  #                             head(knots(MinEcdf), -1)) *
  #                               (MaxEcdf(tail(knots(MinEcdf), -1)) -
  #                                MinEcdf(head(knots(MinEcdf), -1)))
  #
  #   return(sum(areas.of.cdf.uncertainty) / total.area)

  stopifnot(inherits(h, "histogram"))
  # However, this is more succintly expressed as:
  return(sum(diff(h$breaks) * h$counts) / sum(h$counts) /
         diff(range(h$breaks)))
}

PlotKSDCC <- function(h, arrow.size.scale=1, main=paste("KSDCC =", KSDCC(h)),
                      ...) {
  # Plot a CDF from the given histogram along with a red arrow
  # indicating the point of maximum distance between the possible CDFs
  # of the underlying unbinned distribution corresponding to the KSDCC.
  #
  # Args:
  #   h: An S3 histogram object.
  #   arrow.size.scale: An optional value to scale the size of the arrow head
  #   main: A title for the plot.
  #   ...: Additional arguments to pass to plot().

  stopifnot(inherits(h, "histogram"))
  stopifnot(is.character(main), length(main) == 1)
  MinEcdf <- HistToEcdf(h, f=0)
  MaxEcdf <- HistToEcdf(h, f=1)
  plot(MaxEcdf, main=main, ...)

  index.of.max <- which.max(h$counts)
  height <- max(h$counts) / sum(h$counts)
  arrows(x0=knots(MinEcdf)[index.of.max],
         y0=MinEcdf(h$mids[index.of.max]),
         y1=MaxEcdf(h$mids[index.of.max]),
         # TODO(mstokely): (4*height) chosen to work well by default
         # and in a par(mfrow=c(n,k)) environment as in the vignette.
         length=0.25*(4*height)*arrow.size.scale,
         code=3, col="red", lwd=3)
}

PlotEMDCC <- function(h, main=paste("EMDCC =", EMDCC(h)), ...) {
  # Plot a CDF from the given histogram with a yellow boxes
  # covering all possible ranges for the e.c.d.f of the underlying
  # distribution from which the binned histogram was created.
  #
  # Args:
  #   h: An S3 histogram object.
  #   main: A title for the plot.
  #   ...: Additional arguments to pass to plot().

  stopifnot(inherits(h, "histogram"))
  stopifnot(is.character(main), length(main) == 1)
  MinEcdf <- HistToEcdf(h, f=0)
  MaxEcdf <- HistToEcdf(h, f=1)
  plot(MaxEcdf, main=main, ...)
  rect(head(knots(MinEcdf), -1),
       MinEcdf(head(knots(MinEcdf), -1)),
       tail(knots(MinEcdf), -1),
       MaxEcdf(tail(knots(MinEcdf), -1)),
       col="yellow")
}

expect_metric_invariants <- function(metric) {
  expect_true(metric >= 0)
  expect_true(metric <= 1)
}

test_that("KSDCC respects the [0,1] bound and decreases as the histogram refines", {
  set.seed(0)
  x <- rexp(100)
  h1 <- hist(x, plot = FALSE)
  h2 <- hist(x, breaks = seq(0, round(max(x) + 1), by = 0.1), plot = FALSE)

  ksdcc.1 <- KSDCC(h1)
  ksdcc.2 <- KSDCC(h2)

  expect_metric_invariants(ksdcc.1)
  expect_metric_invariants(ksdcc.2)
  expect_true(ksdcc.1 >= ksdcc.2)

  # KSDCC equals the KS statistic between the under- and over-estimate
  # representations of the binned data.
  x1.min <- rep(head(h1$breaks, -1), h1$counts)
  x1.max <- rep(tail(h1$breaks, -1), h1$counts)
  expect_equal(unname(ks.test(x1.min, x1.max, exact = FALSE)$statistic), KSDCC(h1))

  x2.min <- rep(head(h2$breaks, -1), h2$counts)
  x2.max <- rep(tail(h2$breaks, -1), h2$counts)
  expect_equal(unname(ks.test(x2.min, x2.max, exact = FALSE)$statistic), KSDCC(h2))
})

test_that("EMDCC respects [0,1] and matches emdist::emd when emdist is available", {
  set.seed(0)
  x <- rexp(100)
  h1 <- hist(x, plot = FALSE)
  h2 <- hist(x, breaks = seq(0, round(max(x) + 1), by = 0.1), plot = FALSE)

  emdcc.1 <- EMDCC(h1)
  emdcc.2 <- EMDCC(h2)

  expect_metric_invariants(emdcc.1)
  expect_metric_invariants(emdcc.2)
  expect_true(emdcc.1 >= emdcc.2)

  skip_if_not_installed("emdist")

  MinEcdf <- HistToEcdf(h1, f = 0)
  MaxEcdf <- HistToEcdf(h1, f = 1)

  A1 <- matrix(c(rep(1, length(h1$counts)),
                 h1$mids, MaxEcdf(tail(knots(MinEcdf), -1))), ncol = 3)
  A2 <- matrix(c(rep(1, length(h1$counts)),
                 h1$mids, MinEcdf(head(knots(MinEcdf), -1))), ncol = 3)
  # emdist uses single-precision floats internally, hence the 2^-23 tolerance.
  expect_equal(emdist::emd(A1, A2), emdcc.1, tolerance = 2^-23)
})

# ----- PlotKSDCC / PlotEMDCC smoke tests -------------------------------------
# These are pure side-effect plotting wrappers. We verify they run to
# completion on a representative input without erroring; visual
# correctness is out of scope.

with_null_pdf <- function(expr) {
  pdf_file <- tempfile(fileext = ".pdf")
  pdf(pdf_file)
  on.exit({
    dev.off()
    unlink(pdf_file)
  })
  force(expr)
}

test_that("PlotKSDCC runs without error on a histogram", {
  set.seed(0)
  h <- hist(rexp(100), plot = FALSE)
  expect_no_error(with_null_pdf(PlotKSDCC(h)))
})

test_that("PlotKSDCC errors on non-histogram input", {
  expect_error(with_null_pdf(PlotKSDCC(c(1, 2, 3))))
})

test_that("PlotEMDCC runs without error on a histogram", {
  set.seed(0)
  h <- hist(rexp(100), plot = FALSE)
  expect_no_error(with_null_pdf(PlotEMDCC(h)))
})

test_that("PlotEMDCC errors on non-histogram input", {
  expect_error(with_null_pdf(PlotEMDCC(c(1, 2, 3))))
})

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

# Defined in Color Indexing, by Swain and Ballard.
IntersectHistograms <- function(h1, h2) {
  stopifnot(inherits(h1, "histogram"), inherits(h2, "histogram"))
  stopifnot(all(h1$breaks == h2$breaks))
  intersect.counts <- pmin(h1$counts, h2$counts)
  return(.BuildHistogram(h1$breaks, intersect.counts))
}

# Minkowski-form distance described in section 2.1 of
# "The Earth Mover's Distance as a Metric for Image Retrieval"
minkowski.dist <- function(h1, h2, p) {
  stopifnot(inherits(h1, "histogram"), inherits(h2, "histogram"))
  stopifnot(all(h1$breaks == h2$breaks))
  stopifnot(is.numeric(p), length(p) == 1, p > 0)
#  return(dist(t(matrix(c(h1$counts, h2$counts), nrow=2)), "minkowski", p=p))
  return((sum(abs(h1$counts - h2$counts)^p))^(1/p))
}

# Described in EMD paper above, which references
# "Color Indexing", Swain and Ballard, 1991, p15.
intersect.dist <- function(h1, h2) {
  stopifnot(inherits(h1, "histogram"), inherits(h2, "histogram"))
  stopifnot(all(h1$breaks == h2$breaks))
  h3 <- IntersectHistograms(h1, h2)
  return(1 - (sum(h3$counts) / sum(h2$counts)))
}

# Described in EMD paper above, which references
# S. Kullback.  Information Theory and Statistics, Dover, 1968.
kl.divergence <- function(h1, h2) {
  stopifnot(inherits(h1, "histogram"), inherits(h2, "histogram"))
  stopifnot(all(h1$breaks == h2$breaks))
  h1.normcounts <- h1$counts / sum(h1$counts)
  h2.normcounts <- h2$counts / sum(h2$counts)
  return(sum(h1.normcounts * log(h1.normcounts / h2.normcounts)))
}

# In EMD paper above, which references:
# Puzicha, Hoffmann, Buhmann
# Non-parametric similarity measures for unsupervised texture
# segmentation and image retrieval
jeffrey.divergence <- function(h1, h2) {
  stopifnot(inherits(h1, "histogram"), inherits(h2, "histogram"))
  stopifnot(all(h1$breaks == h2$breaks))
  h1.normcounts <- h1$counts / sum(h1$counts)
  h2.normcounts <- h2$counts / sum(h2$counts)
  m <- .BuildHistogram(h1$breaks,
                       (h1.normcounts + h2.normcounts) / 2)
  return(sum(h1.normcounts * log(h1.normcounts / m$counts) +
             h2.normcounts * log(h2.normcounts / m$counts)))
}

# Tests for the two-histogram comparison functions in R/bindist.R:
# IntersectHistograms, minkowski.dist, intersect.dist, kl.divergence,
# jeffrey.divergence.

# A handful of helpers used across the tests below. Building histograms
# with hand-picked counts keeps the expected values easy to verify by
# hand from the formulas.
hist_with_counts <- function(counts, breaks = seq(0, length(counts))) {
  PreBinnedHistogram(breaks = breaks, counts = counts)
}

# ----- IntersectHistograms ---------------------------------------------------

test_that("IntersectHistograms takes elementwise pmin of counts", {
  h1 <- hist_with_counts(c(3, 2, 1))
  h2 <- hist_with_counts(c(1, 2, 3))
  out <- IntersectHistograms(h1, h2)
  expect_s3_class(out, "histogram")
  expect_equal(out$breaks, h1$breaks)
  expect_equal(out$counts, c(1, 2, 1))
})

test_that("IntersectHistograms errors on mismatched breakpoints", {
  h1 <- hist_with_counts(c(1, 1, 1), breaks = 0:3)
  h2 <- hist_with_counts(c(1, 1, 1), breaks = 1:4)
  expect_error(IntersectHistograms(h1, h2))
})

test_that("IntersectHistograms errors when an input is not a histogram", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_error(IntersectHistograms(h, list()))
  expect_error(IntersectHistograms(c(1, 2, 3), h))
})

# ----- minkowski.dist --------------------------------------------------------

test_that("minkowski.dist returns 0 when histograms are identical", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_equal(minkowski.dist(h, h, p = 1), 0)
  expect_equal(minkowski.dist(h, h, p = 2), 0)
})

test_that("minkowski.dist computes L1 distance with p=1", {
  # diff in counts: (4, -1, -1); sum of |diff| = 6
  h1 <- hist_with_counts(c(5, 0, 0))
  h2 <- hist_with_counts(c(1, 1, 1))
  expect_equal(minkowski.dist(h1, h2, p = 1), 6)
})

test_that("minkowski.dist computes L2 distance with p=2", {
  # diff in counts: (3, -4); sum of squares = 25; sqrt = 5
  h1 <- hist_with_counts(c(3, 0))
  h2 <- hist_with_counts(c(0, 4))
  expect_equal(minkowski.dist(h1, h2, p = 2), 5)
})

test_that("minkowski.dist errors on non-positive or non-scalar p", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_error(minkowski.dist(h, h, p = 0))
  expect_error(minkowski.dist(h, h, p = -1))
  expect_error(minkowski.dist(h, h, p = c(1, 2)))
})

test_that("minkowski.dist errors on mismatched breakpoints", {
  h1 <- hist_with_counts(c(1, 1, 1), breaks = 0:3)
  h2 <- hist_with_counts(c(1, 1, 1), breaks = 1:4)
  expect_error(minkowski.dist(h1, h2, p = 1))
})

# ----- intersect.dist --------------------------------------------------------

test_that("intersect.dist is 0 when histograms are identical", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_equal(intersect.dist(h, h), 0)
})

test_that("intersect.dist is 1 when histograms are completely disjoint", {
  # pmin on disjoint supports is all zeros => intersect / sum(h2) = 0
  h1 <- hist_with_counts(c(5, 0))
  h2 <- hist_with_counts(c(0, 5))
  expect_equal(intersect.dist(h1, h2), 1)
})

test_that("intersect.dist matches a hand-computed partial overlap", {
  # pmin((5,5), (3,7)) = (3,5); sum = 8; sum(h2) = 10; 1 - 8/10 = 0.2
  h1 <- hist_with_counts(c(5, 5))
  h2 <- hist_with_counts(c(3, 7))
  expect_equal(intersect.dist(h1, h2), 0.2)
})

# ----- kl.divergence --------------------------------------------------------

test_that("kl.divergence is 0 when histograms are identical (no zero counts)", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_equal(kl.divergence(h, h), 0)
})

test_that("kl.divergence matches a hand-computed two-bin example", {
  # h1 normalized = (0.75, 0.25); h2 normalized = (0.25, 0.75)
  # KL = 0.75 * log(0.75/0.25) + 0.25 * log(0.25/0.75) = 0.5 * log(3)
  h1 <- hist_with_counts(c(3, 1))
  h2 <- hist_with_counts(c(1, 3))
  expect_equal(kl.divergence(h1, h2), 0.5 * log(3))
})

test_that("kl.divergence is asymmetric in general (KL(h1,h2) != KL(h2,h1))", {
  # Note: swap-symmetric distributions like (0.8, 0.2) and (0.2, 0.8) happen
  # to give the same KL in either direction, so we deliberately use a pair
  # that isn't swap-symmetric.
  h1 <- hist_with_counts(c(3, 1))   # normalized (0.75, 0.25)
  h2 <- hist_with_counts(c(2, 2))   # normalized (0.5, 0.5)
  expect_false(isTRUE(all.equal(
    kl.divergence(h1, h2),
    kl.divergence(h2, h1)
  )))
})

# ----- jeffrey.divergence ----------------------------------------------------

test_that("jeffrey.divergence is 0 when histograms are identical", {
  h <- hist_with_counts(c(1, 2, 3))
  expect_equal(jeffrey.divergence(h, h), 0)
})

test_that("jeffrey.divergence is symmetric: J(h1,h2) == J(h2,h1)", {
  h1 <- hist_with_counts(c(3, 1))
  h2 <- hist_with_counts(c(1, 3))
  expect_equal(jeffrey.divergence(h1, h2), jeffrey.divergence(h2, h1))
})

test_that("jeffrey.divergence matches a hand-computed two-bin example", {
  # h1 normalized = (0.75, 0.25); h2 normalized = (0.25, 0.75)
  # m = (0.5, 0.5)
  # J = 0.75 * log(0.75/0.5) + 0.25 * log(0.25/0.5)         # h1 contribution
  #   + 0.25 * log(0.25/0.5) + 0.75 * log(0.75/0.5)         # h2 contribution
  #   = 1.5 * log(1.5) + 0.5 * log(0.5)
  h1 <- hist_with_counts(c(3, 1))
  h2 <- hist_with_counts(c(1, 3))
  expect_equal(jeffrey.divergence(h1, h2), 1.5 * log(1.5) + 0.5 * log(0.5))
})

# Copyright 2012 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

.TrimRightZeroBuckets <- function(x) {
  # Trims the empty buckets in the right-tail of a histogram.
  #
  # Args:
  #   x: An S3 histogram object.
  # Returns:
  #   A new S3 histogram object with any empty buckets in the
  #   right-tail removed.

  # Copy over max/min/sum of squares/class, etc.
  # Override breaks, counts, and midpoints to trim off the rightmost
  # zero buckets.

  if (all(x$counts == 0)) {
    warning("All buckets of histogram zero, returning unmodified.")
    return(x)
  }
  biggest.nonzero <- max(which(x$counts > 0))
  if (biggest.nonzero == length(x$counts)) {
    # Last bucket is non-zero.
    return(x)
  }
  # Since histogram objects are named lists, we can use within
  # to override the necessary elements.
  new.hist <- within(unclass(x), {
    breaks <- head(breaks, biggest.nonzero + 1)
    counts <- head(counts, biggest.nonzero)
    mids <- head(mids, biggest.nonzero)
    density <- head(density, biggest.nonzero)
  })
  attributes(new.hist) <- attributes(x)
  return(new.hist)
}

.TrimLeftZeroBuckets <- function(x) {
  # Trims the empty buckets in the left-tail of a histogram.
  #
  # Args:
  #   x: An S3 histogram object.
  # Returns:
  #   A new S3 histogram object with any empty buckets in the
  #   left-tail removed.

  if (all(x$counts == 0)) {
    warning("All buckets of histogram zero, returning unmodified.")
    return(x)
  }
  smallest.nonzero <- which.max(x$counts > 0)
  if (smallest.nonzero == 1) {
    # First bucket is non-zero.
    return(x)
  }
  new.hist <- within(unclass(x), {
    breaks <- tail(breaks, length(breaks) - smallest.nonzero + 1)
    counts <- tail(counts, length(counts) - smallest.nonzero + 1)
    mids <- tail(mids, length(mids) - smallest.nonzero + 1)
    density <- tail(density, length(density) - smallest.nonzero + 1)
  })
  attributes(new.hist) <- attributes(x)
  return(new.hist)
}

TrimHistogram <- function(x, left=TRUE, right=TRUE) {
  # Trims empty buckets from the left and right tails of a histogram.
  #
  # Args:
  #   x:     An R histogram object.
  #   left:  boolean, if TRUE, remove empty buckets from left tail of histogram.
  #   right: boolean, if TRUE, remove empty buckets from right tail of histogram.
  # Returns:
  #   x:  An R histogram object, possibly with fewer buckets.
  stopifnot(inherits(x, "histogram"))
  tmp.hist <- x
  if (left) {
    tmp.hist <- .TrimLeftZeroBuckets(tmp.hist)
  }
  if (right) {
    tmp.hist <- .TrimRightZeroBuckets(tmp.hist)
  }
  return(tmp.hist)
}

test_that("TrimHistogram drops trailing/leading empty buckets but preserves total count", {
  hist.1 <- hist(c(1, 2, 3), breaks = 0:9, plot = FALSE)
  hist.trimmed <- TrimHistogram(hist.1)
  expect_equal(sum(hist.1$counts), sum(hist.trimmed$counts))
  expect_true(length(hist.1$counts) > length(hist.trimmed$counts))

  hist.2 <- hist(c(4, 5, 6), breaks = 0:9, plot = FALSE)
  hist.trimmed <- TrimHistogram(hist.2)
  expect_equal(sum(hist.2$counts), sum(hist.trimmed$counts))
  expect_true(length(hist.2$counts) > length(hist.trimmed$counts))
})

test_that("TrimHistogram is a no-op when every bucket is empty", {
  zero.hist <- suppressWarnings(
    hist(numeric(), breaks = c(0, 1, 2, 3, 4, 5, 6, 7, 8, 9), plot = FALSE)
  )
  zero.trimmed <- TrimHistogram(zero.hist)
  expect_equal(length(zero.hist$counts), length(zero.trimmed$counts))
})

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

# Requires David W. Scott's ASH code from ash package on CRAN.
HistToASH <- function(h, m=5, kopt=c(2,2)) {
  # Create an Average Shifted Histogram from a histogram.
  #
  # See ?ash1
  #
  # Args:
  #   h:  An S3 histogram object.
  #   m:  Smooth parameter for ash1 function
  #   kopt: Parameter for ash1 function.
  stopifnot(inherits(h, "histogram"))
  if (!h$equidist) {
    stop("Histogram must be equidist to generate an Average Shifted Histogram")
  }
  # Assuming we have a finely bucketed initial histogram.
  bin1 <- list(nc = h$counts,
               ab = range(h$breaks),
               nskip = 0)
  return(ash1(bin1, m, kopt))
}

# Tests for HistToASH (R/ash.R), a thin wrapper around ash::ash1.
# We don't re-test the ash package itself, only that our wrapper hands
# off correctly and validates its inputs.

test_that("HistToASH returns an ash-shaped result on an equidist histogram", {
  set.seed(0)
  h <- hist(rexp(1000), plot = FALSE)
  out <- HistToASH(h)
  # ash1 returns a list with at least 'x' and 'y' components.
  expect_true(is.list(out))
  expect_true(all(c("x", "y") %in% names(out)))
  expect_equal(length(out$x), length(out$y))
})

test_that("HistToASH errors on non-histogram input", {
  expect_error(HistToASH(c(1, 2, 3)))
  expect_error(HistToASH(list()))
})

test_that("HistToASH errors on a non-equidist histogram", {
  # PreBinnedHistogram with deliberately uneven breaks.
  h <- PreBinnedHistogram(breaks = c(0, 1, 3, 7), counts = c(2, 5, 1))
  expect_false(h$equidist)
  expect_error(HistToASH(h), "equidist")
})

# Copyright 2012 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

Count <- function(x) {
  stopifnot(inherits(x, "histogram"))
  return (sum(x$counts))
}

ApproxMean <- function(x) {
  stopifnot(inherits(x, "histogram"))
  return (weighted.mean(x$mids, x$counts))
}

# TODO(mstokely): Using only the midpoints and counts throws away the
# information about the breakpoints, which could potentially be used
# to provide more accurate approximations.  An alternative slower
# implementation based on cumsum may be added back here.
# Tim suggests using approx there:
# approx(cumsum(c(0, x$counts)) / sum(x$counts, x$breaks, probs, ...)

# wtd.quantile is from Hmisc package.
ApproxQuantile <- function(x, probs, ...) {
  stopifnot(inherits(x, "histogram"))
  if (length(x$mids) < 100) {
    warning("Quantiles computed for histograms with fewer than 100 buckets ",
            "may be inaccurate. Consider using histograms with more granular ",
            "buckets.")
  }
  stopifnot(inherits(x, "histogram"))
  return (wtd.quantile(x$mids, weights=x$counts, probs=probs, ...))
}

test_that("ApproxMean computes the bin-midpoint-weighted mean", {
  x <- hist(c(1, 2, 3, 4), plot = FALSE)
  # x$breaks = 1 2 3 4 ; x$counts = 2 1 1
  expect_equal(ApproxMean(x), 2.25)
})

test_that("ApproxQuantile is monotonic and brackets the median bin", {
  x <- hist(c(1, 2, 3, 4), plot = FALSE)
  # The bucketing means a reasonable approximation for the median is in [1.5, 2.5].
  expect_true(unname(ApproxQuantile(x, .5)) >= 1.5)
  expect_true(unname(ApproxQuantile(x, .5)) <= 2.5)
  expect_true(ApproxQuantile(x, .5) < ApproxQuantile(x, .51))
  # The midpoint of the last bucket is the approximation of the 100th percentile.
  expect_equal(unname(ApproxQuantile(x, 1)), max(x$mids))
})

# Copyright 2011 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

.BreaksAreEquidistant <- function(breaks) {
  # Check if breaks are equally spaced.
  # If we had integer breakpoints we could just use
  # hist$equidist <- length(unique(diff(hist$breaks))) == 1
  diffs <- diff(breaks)
  all(abs(diffs - diffs[1]) < .Machine$double.eps^0.5 * max(diffs))
}

PreBinnedHistogram <- .BuildHistogram <- function(breaks, counts, xname="") {
  # Returns a histogram object from the given list of breaks and counts.

  stopifnot(is.numeric(breaks), is.numeric(counts))
  stopifnot(length(breaks) > 1)
  stopifnot(length(breaks) == (length(counts) + 1))
  hist <- list(breaks = breaks,
               counts = counts,
               density = counts / (sum(counts) * diff(breaks)),
               mids = (head(breaks, -1) + tail(breaks, -1)) / 2,
               xname = xname,
               equidist = .BreaksAreEquidistant(breaks))
  class(hist) <- "histogram"
  return(hist)
}

.UpdateHistogram <- function(x) {
  # Takes a histogram with possibly modified counts and breaks and updates
  # all other required fields to be consistent.

  stopifnot(inherits(x, "histogram"))
  stopifnot(is.numeric(x$breaks), is.numeric(x$counts))
  stopifnot(length(x$breaks) > 1)
  stopifnot(length(x$breaks) == (length(x$counts) + 1))
  x$density <- x$counts / (sum(x$counts) * diff(x$breaks))
  x$mids <-  (head(x$breaks, -1) + tail(x$breaks, -1)) / 2
  x$equidist <- .BreaksAreEquidistant(x$breaks)
  return(x)
}

.NewHistogramName <- function(x) {
  if(length(x) == 2) {
    return(paste("Merge of", x[[1]]$xname, "and", x[[2]]$xname))
  } else {
    paste("Merge of", length(x), "histograms")
  }
}

.AddManyHistograms <- function(x, main=.NewHistogramName(x)) {
  # Adds many histogram objects together that have the same bins.
  #
  # TODO(mstokely): Relax the requirement that the histograms have exactly
  # the same bins.
  #
  # Args:
  #   x: A list of S3 histogram objects
  #   main:  The name to set for the merged histogram (e.g. used in plots).
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.
  stopifnot(all(sapply(x, inherits, "histogram")))
  br <- unname(lapply(x, function(y) y$breaks))
  if (!all((sapply(br, identical, y = br[[1]])))) {
    stop("Histograms must have identical breakpoints for this operation.")
  }
  # Now we know that all histograms have identical breaks.
  cnts <- unname(lapply(x, function(y) y$counts))
  sum.cnts <- Reduce("+", cnts)
  return(.BuildHistogram(breaks = x[[1]]$breaks,
                         counts = sum.cnts,
                         xname = main))
}

AddHistograms <- function(..., x=list(...), main=.NewHistogramName(x)) {
  # Adds two histogram objects that have the same bins.
  #
  # TODO(mstokely): Support histograms without exactly the same breaks.
  #
  # Args:
  #   ...: S3 histogram objects.
  #   x:   A list of S3 histogram objects.
  #   main:  The name to set for the merged histogram (e.g. used in plots).
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.

  stopifnot(length(x) > 0)
  if (length(x) == 1) {
    return(x)
  } else {
    # length > 1
    return(.AddManyHistograms(x, main=main))
  }
}

ScaleHistogram <- function(x, factor=1 / Count(x)) {
  # Scale the counts of each bucket in a histogram by a factor.
  #
  # Args:
  #   x:       A histogram object.
  #   factor:  Scaling factor for the counts.
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.

  stopifnot(inherits(x, "histogram"))
  stopifnot(is.numeric(factor), length(factor) == 1)
  x$counts <- x$counts * factor
  return(.UpdateHistogram(x))
}

# S3 Generics

as.histogram <- function(x, ...) {
  UseMethod("as.histogram")
}

# TODO(mstokely): RProtoBuf confusingly uses asMessage instead of as.Message
as.Message <- function(x) {
  UseMethod("as.Message")
}

as.histogram.Message <- function(x, ...) {
  # Converts a Protocol Buffer into an R Histogram.
  #
  # Args:
  #   x: An RProtoBuf Message of type HistogramTools.HistogramState.
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.
  stopifnot(inherits(x, "Message"))

  if (x@type != "HistogramTools.HistogramState") {
    stop(paste("Unknown protocol message type", x@type, "only",
               "HistogramTools.HistogramState supported"))
  }
  hist <- .BuildHistogram(breaks = x$breaks, counts = x$counts)
  if (x$has("name")) {
    hist$xname <- x$name
  } else {
    hist$xname <- "HistogramTools.HistogramState"
  }
  return(hist)
}

as.Message.histogram <- function(x) {
  # Converts an R S3 histogram class into a HistogramState ProtoBuf.
  #
  # Args:
  #   x: An S3 histogram object.
  #
  # Returns:
  #   An RProtoBuf message of type HistogramTools.HistogramState
  stopifnot(inherits(x, "histogram"))
  # This catches NAs
  stopifnot(!is.null(x$breaks))
  stopifnot(is.numeric(x$breaks))
  if (!requireNamespace("RProtoBuf", quietly = TRUE)) {
      stop("RProtoBuf required to convert Histograms to Protocol Buffer Messages.")
  }

  # We can't conditionally require RProtoBuf and do this in onload()
  if (("RProtoBuf:DescriptorPool" %in% search()) &&
      !exists("HistogramTools.HistogramState",
              where="RProtoBuf:DescriptorPool")) {
    RProtoBuf::readProtoFiles(package="HistogramTools")
  }

  hist.class <- RProtoBuf::P("HistogramTools.HistogramState")
  # new is made generic in RProtoBuf, and we are not importing new in the
  # namespace so reference it explicitly here.
  hist.msg <- RProtoBuf::new(hist.class)

  hist.msg$counts <- x$counts
  hist.msg$breaks <- x$breaks
  hist.msg$name <- x$xname
  return(hist.msg)
}

# NB(mstokely): This causes an R CMD check warning about
# the histogram class being undocumented, so commented out.
#
# This would let us do :
#   as(hist(runif(100), plot=F), "Message")
#
# But we can already accomplish that with :
#   as.Message(hist(runif(100), plot=F))
#
# so it is not a big loss.
#setOldClass("histogram")
#setAs("histogram", "Message", as.Message.histogram)

test_that("AddHistograms sums two histograms with identical breaks", {
  hist.1 <- hist(c(1, 2, 3, 4), plot = FALSE)
  hist.2 <- hist(c(1, 2, 2, 4), plot = FALSE)
  hist.sum <- AddHistograms(hist.1, hist.2)
  expect_equal(hist.sum$breaks, c(1, 2, 3, 4))
  expect_equal(hist.sum$counts, c(5, 1, 2))
})

test_that("AddHistograms sums many histograms in either calling form", {
  hist.1 <- hist(c(1, 2, 3), breaks = 0:9, plot = FALSE)
  hist.2 <- hist(c(1, 2, 3), breaks = 0:9, plot = FALSE)
  hist.3 <- hist(c(4, 5, 6), breaks = 0:9, plot = FALSE)

  hist.sum <- AddHistograms(hist.1, hist.2, hist.3)
  expect_equal(hist.sum$breaks, 0:9)
  expect_equal(hist.sum$counts, c(2, 2, 2, 1, 1, 1, 0, 0, 0))

  hist.sum <- AddHistograms(x = list(hist.1, hist.2, hist.3))
  expect_equal(hist.sum$breaks, 0:9)
  expect_equal(hist.sum$counts, c(2, 2, 2, 1, 1, 1, 0, 0, 0))
})

test_that("MergeBuckets coarsens by adjacency, by count, and by explicit breaks", {
  hist.1 <- hist(c(1, 2, 3), breaks = 0:9, plot = FALSE)

  hist.2 <- MergeBuckets(hist.1, adj = 2)
  expect_equal(hist.2$breaks, c(0, 2, 4, 6, 8, 9))
  expect_equal(hist.2$counts, c(2, 1, 0, 0, 0))

  hist.3 <- MergeBuckets(hist.1, breaks = 3)
  expect_equal(hist.3$breaks, c(0, 3, 6, 9))
  expect_equal(hist.3$counts, c(3, 0, 0))

  # Breakpoint list that is not a subset of the existing list errors out.
  expect_error(MergeBuckets(hist.1, breaks = c(17, 34)))

  hist.4 <- MergeBuckets(hist.1, breaks = c(0, 3, 6, 9))
  expect_equal(hist.4$breaks, c(0, 3, 6, 9))
  expect_equal(hist.4$counts, c(3, 0, 0))

  # A breakpoint range that would drop existing buckets errors out.
  expect_error(MergeBuckets(hist.1, breaks = 2:9))

  hist.5 <- hist(c(1, 2, 3), breaks = 0:10, plot = FALSE)
  hist.6 <- MergeBuckets(hist.5, adj = 2)
  expect_equal(hist.6$breaks, c(0, 2, 4, 6, 8, 10))
  expect_equal(hist.6$counts, c(2, 1, 0, 0, 0))
})

# ----- Count -----------------------------------------------------------------

test_that("Count returns the sum of counts", {
  h <- PreBinnedHistogram(breaks = 0:4, counts = c(7, 3, 0, 2))
  expect_equal(Count(h), 12)
})

test_that("Count errors on non-histogram input", {
  expect_error(Count(c(1, 2, 3)))
})

# ----- ScaleHistogram --------------------------------------------------------

test_that("ScaleHistogram with explicit factor scales counts linearly", {
  h <- PreBinnedHistogram(breaks = 0:3, counts = c(1, 2, 3))
  out <- ScaleHistogram(h, factor = 10)
  expect_equal(out$counts, c(10, 20, 30))
  expect_equal(out$breaks, h$breaks)
})

test_that("ScaleHistogram default factor (1/Count) normalizes counts to sum to 1", {
  h <- PreBinnedHistogram(breaks = 0:3, counts = c(1, 2, 3))
  out <- ScaleHistogram(h)
  expect_equal(sum(out$counts), 1)
})

test_that("ScaleHistogram errors on non-histogram input or non-scalar factor", {
  h <- PreBinnedHistogram(breaks = 0:3, counts = c(1, 2, 3))
  expect_error(ScaleHistogram(c(1, 2, 3), factor = 2))
  expect_error(ScaleHistogram(h, factor = c(1, 2)))
  expect_error(ScaleHistogram(h, factor = "two"))
})

# ----- PreBinnedHistogram ----------------------------------------------------

test_that("PreBinnedHistogram constructs a valid histogram object", {
  h <- PreBinnedHistogram(breaks = 0:5, counts = c(1, 2, 3, 4, 5), xname = "demo")
  expect_s3_class(h, "histogram")
  expect_equal(h$breaks, 0:5)
  expect_equal(h$counts, c(1, 2, 3, 4, 5))
  expect_equal(h$mids, c(0.5, 1.5, 2.5, 3.5, 4.5))
  expect_true(h$equidist)
  expect_equal(h$xname, "demo")
})

test_that("PreBinnedHistogram detects non-equidist breaks", {
  h <- PreBinnedHistogram(breaks = c(0, 1, 3, 7), counts = c(2, 5, 1))
  expect_false(h$equidist)
})

# ----- AddHistograms edge cases ----------------------------------------------

test_that("AddHistograms with a single histogram returns it (length-1 path)", {
  h <- PreBinnedHistogram(breaks = 0:3, counts = c(1, 2, 3))
  out <- AddHistograms(h)
  # The length(x) == 1 branch returns the list itself.
  expect_equal(out, list(h))
})

test_that("AddHistograms errors when histograms have mismatched breakpoints", {
  h1 <- PreBinnedHistogram(breaks = 0:3, counts = c(1, 1, 1))
  h2 <- PreBinnedHistogram(breaks = 1:4, counts = c(1, 1, 1))
  expect_error(AddHistograms(h1, h2), "identical breakpoints")
})

# ----- Protocol Buffer round-trip --------------------------------------------

test_that("histogram <-> protobuf round-trips identically when RProtoBuf is available", {
  skip_if_not_installed("RProtoBuf")

  set.seed(0)
  h <- hist(rexp(100), plot = FALSE)
  msg <- as.Message(h)
  expect_s4_class(msg, "Message")

  back <- as.histogram(msg)
  expect_s3_class(back, "histogram")
  expect_equal(back$breaks, h$breaks)
  expect_equal(back$counts, h$counts)
  expect_equal(back$mids, h$mids)
})

test_that("as.histogram on a non-HistogramState message errors with a clear message", {
  skip_if_not_installed("RProtoBuf")

  # Construct a message of an unrelated descriptor type. RProtoBuf ships
  # tutorial.proto with descriptor `tutorial.Person`, which we use here
  # as a foreign type.
  if (!exists("tutorial.Person",
              where = "RProtoBuf:DescriptorPool",
              inherits = FALSE)) {
    skip("tutorial.Person descriptor not in RProtoBuf descriptor pool")
  }
  foreign <- RProtoBuf::new(RProtoBuf::P("tutorial.Person"), id = 1, name = "x")
  expect_error(as.histogram(foreign), "Unknown protocol message type")
})

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

ReadHistogramsFromDtraceOutputFile <- function(filename) {
  # Read the output of the dtrace tool and return a list of R histograms.
  #
  # The dtrace tool can output histograms of system quantities in a textual
  # representation.  This function parses those into R histogram objects for
  # further statistical analysis.
  #
  # Args:
  #   filename: The text output file of dtrace that includes distributions.
  #
  # Returns:
  #   A list of S3 histogram objects suitable for plotting.

  stopifnot(is.character(filename), length(filename) == 1)
  stopifnot(file.exists(filename))
  dtrace.text <- readLines(filename)
  dividers <- grepl("--- Distribution ---", dtrace.text)

  # lengths for each
  lengths <- diff(c(which(dividers), length(dtrace.text)))

  start <- which(dividers) - 1
  lengths1 <- lengths - 1
  myh <- sapply(1:length(start), function(i) {
    dtrace.text[start[i] + 0:lengths1[i]]
  })

  myhists <- lapply(myh, .BuildSingleHistogramFromDtraceOutput)
  names(myhists) <- lapply(myhists, function(x) trimws(x$xname))
  return(myhists)
}

.BuildSingleHistogramFromDtraceOutput <- function(textlines) {
  # Build a single histogram from a portion of the text output of dtrace.
  #
  # The ReadHistogramsFromDtraceOutputFile() function breaks up the text
  # output of dtrace into individual chunks corresponding to different
  # distributions and then calls this function on each subset to generate
  # a single histogram.  textlines is of the form:
  #
  #[1] "  tcsh                                              "
  #[2] "           value  ------------- Distribution ------------- count    "
  #[3] "               0 |                                         0        "
  #[4] "               1 |@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 4        "
  #[5] "               2 |                                         0        "
  #[6] ""
  #
  # Args:
  #   textlines: A character vector of the portion of dtrace output for one hist
  #
  # Returns:
  #   An S3 histogram object suitable for plotting.

  stopifnot(is.character(textlines), length(textlines) > 3)
  stopifnot(grepl("-- Distribution --", textlines[2]))
  textlines <- textlines[nzchar(textlines)]
  title <- textlines[1]
  headerline <- textlines[2]
  value.rightoffset <- regexpr("value", headerline, fixed=T)[1] + nchar("value")
  count.leftoffset <- regexpr("count", headerline, fixed=T)[1]
  bins <- as.numeric(sub("(^.*)\\|.*", "\\1", tail(textlines, -2)))
  counts <- as.numeric(sub("^.{59}(.*)", "\\1", tail(textlines, -2)))
  return(.BuildHistogram(breaks = bins,
                         # remove the last bin from counts, always 0.
                         counts = head(counts, -1),
                         xname = title))
}

test_that("ReadHistogramsFromDtraceOutputFile parses 54 histograms from the FreeBSD fixture", {
  filename <- system.file(
    "extdata/buildkernel-readsize-dtrace.txt",
    package = "HistogramTools"
  )
  dtrace.hists <- ReadHistogramsFromDtraceOutputFile(filename)
  expect_equal(length(dtrace.hists), 54)
  expect_true(all(sapply(dtrace.hists, inherits, "histogram")))
})

# Copyright 2012 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

# TODO(mstokely): Consider: MergeAllEmptyBuckets() to compress empty buckets.

.MergeBucketsToBreakList <- function(x, breaks, FUN=sum) {
  # Merge adjacent buckets of a Histogram given a subset of the original breaks.
  #
  # This function combines adjacent buckets such that the returned
  # histogram has 'breaks' as breakpoints; breaks must be a subset of
  # the original breakpoints.
  #
  # Args:
  #   x:         An S3 histogram object
  #   breaks:    a vector giving the breakpoints between cells.
  #   FUN:       The function used to merge buckets.  Using anything other than
  #              sum here would break the density so use with care.
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.

  stopifnot(is.numeric(breaks), length(breaks) > 1)
  if (!all(breaks %in% x$breaks)) {
    stop("List of breaks must be subset of existing breaks in histogram")
  }

  if (!isTRUE(all.equal(range(breaks), range(x$breaks)))) {
    stop("Range of new breakpoints too small.  Use SubsetHistogram first.")
  }
  # TODO(mstokely): Make this work and subset the histogram with a warning.
  #  if (max(breaks) < max(x$breaks)) {
  #    warning("Trimming buckets from histogram.")
  #    x <- SubsetHistogram(x, maxbreak=max(breaks))
  #  }
  #  if (min(breaks) < min(x$breaks)) {
  #    warning("Trimming buckets from histogram.")
  #    x <- SubsetHistogram(x, minbreak=min(breaks))
  #  }

  i <- which(x$breaks %in% breaks)
  bucket.grouping <- rep(head(breaks, -1), diff(i))
  tmp.df <- aggregate(x$counts, by=list(breaks=bucket.grouping), FUN)

  x$counts <- tmp.df$x
  x$breaks <- c(tmp.df$breaks, tail(x$breaks, 1))

  # Updated the other named list elements of the histogram class and return.
  return(.UpdateHistogram(x))
}

MergeBuckets <- function(x, adj.buckets=NULL, breaks=NULL, FUN=sum) {
  # Merge adjacent buckets of a Histogram.
  #
  # This only makes sense where the new bucket boundaries are a subset
  # of the previous bucket boundaries.  Only one of adj.buckets or
  # breaks should be specified.
  #
  # Args:
  #   x: An S3 histogram object
  #   adj.buckets: The number of adjacent buckets to merge.
  #   breaks: a vector giving the breakpoints between cells, or a
  #     single number giving number of cells.  Must have same range
  #     as x$breaks.
  #   FUN: The function used to merge buckets.  Using anything other than
  #     sum here would break the density so use with care.
  #
  # Returns:
  #   An S3 histogram class suitable for plotting.
  stopifnot(inherits(x, "histogram"))
  if (is.null(adj.buckets)) {
    stopifnot(is.numeric(breaks), length(breaks) > 0)
    if (length(breaks) > 1) {
      return(.MergeBucketsToBreakList(x, breaks, FUN))
    }
    stopifnot(breaks < length(x$breaks))
    # How many new buckets will we have.
    new.bucket.count <- breaks
    adj.buckets <- ceiling(length(x$counts) / new.bucket.count)
  } else {
    stopifnot(is.numeric(adj.buckets), length(adj.buckets) == 1,
              adj.buckets > 1)
    if (!is.null(breaks)) {
      stop("Only one of adj.buckets and breaks should be specified.")
    }
    new.bucket.count <- ceiling(length(x$counts) / adj.buckets)
  }

  # The last bucket may not be full, hence the length.out
  # TODO(mstokely): Consider bucket.grouping <- x$breaks[
  #                             ceiling(seq_along(x$counts) / adj.buckets)]
  # or: seq(from = 1, by = adj.buckets, length = new.bucket.count + 1)
  bucket.grouping <- rep(x$breaks[1+(0:new.bucket.count)*adj.buckets],
                         each=adj.buckets, length.out=length(x$counts))

  tmp.df <- aggregate(x$counts, by=list(breaks=bucket.grouping), FUN)

  x$counts <- tmp.df$x
  x$breaks <- c(tmp.df$breaks, tail(x$breaks, 1))

  # Updated the other named list elements of the histogram class and return.
  return(.UpdateHistogram(x))
}

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

HistToEcdf <- function(h, method="constant", f=0, inverse=FALSE) {
  # Compute an empirical cumulative distribution function from a histogram.
  #
  # Args:
  #   h:  An S3 histogram object.
  #   method: specifies the interpolation method to be used in call to
  #      approxfun().  Choices are ‘"linear"’ or ‘"constant"’.
  #   f: for ‘method="constant"’ a number between 0 and 1 inclusive,
  #      indicating a compromise between left- and right-continuous
  #      step functions.  See ?approxfun
  #   inverse: If TRUE, return the inverse function.
  #
  # Returns:
  #   An empirical cumulative distribution function (see ?ecdf)

  n <- sum(h$counts)
  # We don't want to use h$mids here, because we want at least
  # to get the correct answers at the breakpoints.
  x.vals <- h$breaks
  y.vals <- c(0, cumsum(h$counts) / n)
  if (inverse) {
    vals.tmp <- x.vals
    x.vals <- y.vals
    y.vals <- vals.tmp
  }
  rval <- approxfun(x.vals, y.vals,
                    method = method, yleft = 0, yright = 1, f = f,
                    ties = "ordered")
  class(rval) <- c("ecdf", "stepfun", class(rval))
  assign("nobs", n, envir = environment(rval))
  attr(rval, "call") <- sys.call()
  rval
}

test_that("HistToEcdf inverse round-trips at the inverse function's knots", {
  set.seed(0)
  x <- rexp(100)
  h <- hist(x, plot = FALSE)
  f <- HistToEcdf(h)
  f.inv <- HistToEcdf(h, inverse = TRUE)
  expect_identical(
    knots(f.inv),
    sapply(knots(f.inv), function(x) f(f.inv(x)))
  )
})

test_that("HistToEcdf brackets the data range and matches cumulative counts", {
  set.seed(0)
  x <- rexp(100)
  h <- hist(x, plot = FALSE)
  f <- HistToEcdf(h)
  expect_true(min(knots(f)) < min(range(x)))
  expect_true(max(knots(f)) > max(range(x)))

  expect_equal(f(h$breaks[3]), (cumsum(h$counts) / sum(h$counts))[2])
})

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

PlotRelativeFrequency <- function(x, ylab="Relative Frequency", ...) {
# Plots relative frequency histogram.
#
# By default R plots only absolute frequency or density.
#
# Args:
#   x:    A histogram
#   ...:  Additional arguments to pass to plot()
  x <- ScaleHistogram(x, 1 / Count(x))
  plot(x, freq=TRUE, ylab=ylab, ...)
}

PlotLog2ByteEcdf <- function(x,
                             xlab="Bytes (log)",
                             ylab="Cumulative Fraction",
                             with.grid=TRUE,
                             ...) {
# Plots ECDF of a histogram with power of 2 byte boundaries.
#
# Args:
#   x: A histogram or ecdf object.
#   with.grid: If TRUE, draw a faint grid on the plot.
#   cex.axis: cex parameter for the axes.
#   ...: Additional arguments to pass to plot()
  if (inherits(x, "histogram")) {
    x <- HistToEcdf(x)
  }
  stopifnot(inherits(x, "ecdf"))
  power.of.two.breaks <- intersect(knots(x), 2^(0:53))
  if (length(power.of.two.breaks) < 3) {
    stop("Insufficient powers of 2 in knots() of ecdf")
  }
  plot(knots(x), x(knots(x)),
       type="l",
       lwd=2,
       log="x",
       xaxt="n",
       las=1,
       xlab=xlab,
       ylab=ylab,
       ...
       )
  if (requireNamespace("gdata", quietly=TRUE)) {
    labs <- gdata::humanReadable(power.of.two.breaks)
  } else {
    labs <- power.of.two.breaks
  }
  axis(1, at=power.of.two.breaks, labels=labs)
  if (with.grid) {
    abline(h=seq(.2,.8, by=.2), lty="dotted", col="lightgray")
    abline(v=power.of.two.breaks, lty="dotted", col="lightgray")
  }
}

PlotLogTimeDurationEcdf <- function(x, with.grid=TRUE,
                                    xlab="Age (log)",
                                    ylab="Cumulative Fraction",
                                    cex.lab=1.6,
                                    cex.axis=1.6, ...) {
# Plots weighted ECDF of a histogram with log time bucket boundaries
# (seconds since the epoch) with log-scaled x-axis labels from 1 minute
# to 1 year.
#
# Args:
#   x: A histogram or ecdf object.
#   with.grid: If TRUE, draw a faint grid on the plot.
#   cex.axis: cex parameter for the axes.
#   ...: Additional arguments to pass to plot()

  if (inherits(x, "histogram")) {
    x <- HistToEcdf(x)
  }
  stopifnot(inherits(x, "ecdf"))

  plot(knots(x), x(knots(x)),
       type="l",
       log="x",
       xaxt="n",
       xlab=xlab,
       ylab=ylab,
       yaxt="n",
       cex.lab=cex.lab,
       ...)

  xticks <- list("1s" = 1,
                 "10s" = 10,
                 "1m" = 60,
                 "10m" = 60 * 10,
                 "1h" = 3600,
                 "6h" = 3600 * 6,
                 "1d" = 86400,
                 "3d" = 86400 * 3,
                 "7d" =  86400 * 7,
                 "30d" = 86400 * 30,
                 "90d" = 86400 * 30 * 3,
                 "1y" = 86400 * 365,
                 "10y" = 86400 * 365 * 10)

  axis(1, at=unlist(xticks), labels=names(xticks), cex.axis=cex.axis)
  axis(2, at=seq(0, 1, by=.2), las=1, cex.axis=cex.axis)

  if (with.grid) {
    abline(h=seq(.2,.8, by=.2), lty="dotted", col="lightgray")
    abline(v=xticks, lty="dotted", col="lightgray")
  }
}

# Smoke tests for the plot wrappers in R/plot.R. These verify that the
# functions run to completion without erroring on representative input;
# visual correctness is out of scope (use vdiffr if that ever matters).
#
# Each test opens a null PDF device so we don't try to render to the
# active device during R CMD check.

with_null_pdf <- function(expr) {
  pdf_file <- tempfile(fileext = ".pdf")
  pdf(pdf_file)
  on.exit({
    dev.off()
    unlink(pdf_file)
  })
  force(expr)
}

# ----- PlotRelativeFrequency -------------------------------------------------

test_that("PlotRelativeFrequency runs without error on a simple histogram", {
  set.seed(0)
  h <- hist(runif(100), plot = FALSE)
  expect_no_error(with_null_pdf(PlotRelativeFrequency(h)))
})

# ----- PlotLog2ByteEcdf ------------------------------------------------------

# A histogram whose breaks land on powers of 2 from 2^0 .. 2^10. That gives
# 11 power-of-2 boundaries -- well above the >= 3 the function requires.
.pow2_histogram <- function() {
  breaks <- 2^(0:10)
  counts <- rep(10, length(breaks) - 1)
  PreBinnedHistogram(breaks = breaks, counts = counts)
}

test_that("PlotLog2ByteEcdf runs on a histogram with power-of-2 breaks", {
  expect_no_error(with_null_pdf(PlotLog2ByteEcdf(.pow2_histogram())))
})

test_that("PlotLog2ByteEcdf accepts a pre-computed ecdf", {
  e <- HistToEcdf(.pow2_histogram())
  expect_no_error(with_null_pdf(PlotLog2ByteEcdf(e)))
})

test_that("PlotLog2ByteEcdf errors when the ecdf has fewer than 3 powers-of-2 in its knots", {
  # Breaks deliberately not aligned to powers of two -> 0 power-of-2 knots.
  h <- PreBinnedHistogram(breaks = c(3, 5, 7, 9), counts = c(1, 2, 3))
  expect_error(with_null_pdf(PlotLog2ByteEcdf(h)), "Insufficient powers of 2")
})

# ----- PlotLogTimeDurationEcdf ----------------------------------------------

test_that("PlotLogTimeDurationEcdf runs on a histogram with time-duration-shaped breaks", {
  # Breaks roughly at 1s, 1m, 1h, 1d, 1w, 1mo, 1y in seconds.
  breaks <- c(1, 60, 3600, 86400, 86400 * 7, 86400 * 30, 86400 * 365)
  counts <- rep(5, length(breaks) - 1)
  h <- PreBinnedHistogram(breaks = breaks, counts = counts)
  expect_no_error(with_null_pdf(PlotLogTimeDurationEcdf(h)))
})

test_that("PlotLogTimeDurationEcdf accepts a pre-computed ecdf", {
  breaks <- c(1, 60, 3600, 86400, 86400 * 7, 86400 * 30, 86400 * 365)
  counts <- rep(5, length(breaks) - 1)
  e <- HistToEcdf(PreBinnedHistogram(breaks = breaks, counts = counts))
  expect_no_error(with_null_pdf(PlotLogTimeDurationEcdf(e)))
})

# Copyright 2013 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Author: mstokely@google.com (Murray Stokely)

# Subset histogram should return the parts of the histogram between the
# specified breakpoints minbreak and maxbreak.
SubsetHistogram <- function(x, minbreak=NULL, maxbreak=NULL) {
  stopifnot(inherits(x, "histogram"))
  if (is.null(minbreak) && is.null(maxbreak)) {
    warning("No new breakpoints specified, returning original histogram.")
    return(x)
  }
  if (!is.null(minbreak)) {
    stopifnot(is.numeric(minbreak), length(minbreak) == 1)
    stopifnot(minbreak %in% x$breaks)
    if (minbreak == min(x$breaks)) {
      return(x)
    }
    # How many bins to cut from left side of histogram?
    num.to.cut <- sum(x$breaks < minbreak)
    x$breaks <- tail(x$breaks, -num.to.cut)
    x$counts <- tail(x$counts, -num.to.cut)
  }
  if (!is.null(maxbreak)) {
    stopifnot(is.numeric(maxbreak), length(maxbreak) == 1)
    stopifnot(maxbreak %in% x$breaks)
    if (maxbreak == max(x$breaks)) {
      return(x)
    }
    # How many bins to cut from right side of histogram?
    num.to.cut <- length(which(x$breaks > maxbreak))
    x$breaks <- head(x$breaks, -num.to.cut)
    x$counts <- head(x$counts, -num.to.cut)
  }
  # Return a new histogram to update density, mids fields.
  return(.BuildHistogram(x$breaks, x$counts, x$xname))
}

test_that("SubsetHistogram trims to the requested range", {
  hist.1 <- hist(c(1, 1, 2, 2, 7), breaks = 0:9, plot = FALSE)
  hist.subset <- SubsetHistogram(hist.1, maxbreak = 3)
  expect_equal(hist.subset$breaks, c(0, 1, 2, 3))
  expect_equal(hist.subset$counts, c(2, 2, 0))
})

test_that("SubsetHistogram errors on out-of-range or non-existent breakpoints", {
  hist.1 <- hist(c(1, 1, 2, 2, 7), breaks = 0:9, plot = FALSE)

  # Out of range
  expect_error(SubsetHistogram(hist.1, minbreak = -100))
  expect_error(SubsetHistogram(hist.1, maxbreak = 100))

  # In range but not an existing breakpoint
  expect_error(SubsetHistogram(hist.1, minbreak = 0.5))
  expect_error(SubsetHistogram(hist.1, maxbreak = 6.5))
})

test_that("SubsetHistogram is a no-op when bounds match the existing endpoints", {
  hist.1 <- hist(c(1, 1, 2, 2, 7), breaks = 0:9, plot = FALSE)

  hist.nosubset <- SubsetHistogram(hist.1, minbreak = 0)
  expect_equal(hist.nosubset$breaks, hist.1$breaks)
  expect_equal(hist.nosubset$counts, hist.1$counts)

  hist.nosubset <- SubsetHistogram(hist.1, maxbreak = 9)
  expect_equal(hist.nosubset$breaks, hist.1$breaks)
  expect_equal(hist.nosubset$counts, hist.1$counts)
})

test_that("SubsetHistogram with both bounds NULL warns and returns the input", {
  hist.1 <- hist(c(1, 1, 2, 2, 7), breaks = 0:9, plot = FALSE)
  expect_warning(
    out <- SubsetHistogram(hist.1),
    "No new breakpoints specified"
  )
  expect_equal(out, hist.1)
})

\documentclass[10pt,twocolumn]{article}
%\VignetteIndexEntry{HistogramTools-QuickRef}

%\DefineVerbatimEnvironment{Sinput}{Verbatim} {xleftmargin=2em}
%\DefineVerbatimEnvironment{Soutput}{Verbatim}{xleftmargin=2em}
%\DefineVerbatimEnvironment{Scode}{Verbatim}{xleftmargin=2em}
%\fvset{listparameters={\setlength{\topsep}{0pt}}}
%\renewenvironment{Schunk}{\vspace{\topsep}}{\vspace{\topsep}}

\setlength{\hoffset}{-0.8in}
\setlength{\voffset}{-0.8in}

\setlength{\marginparwidth}{0pt}
\setlength{\marginparsep}{0pt}
\setlength{\oddsidemargin}{0.1in}
\setlength{\headheight}{0pt}
\setlength{\topmargin}{1pt}
\setlength{\headsep}{0pt}
\setlength{\footskip}{0pt}
\setlength{\textheight}{26.7cm}
%\setlength{\textheight}{10in}
\setlength{\textwidth}{18cm}
\setlength{\columnsep}{1cm}
%\setlength{\textwidth}{8in}

\usepackage[colorlinks]{hyperref}

<<echo=FALSE,print=FALSE>>=
oldoptions <- options(width=50)
oldpar <- par(no.readonly = TRUE)
library(HistogramTools)
set.seed(0)
ht.version <- packageDescription("HistogramTools")$Version
@
% closing $ needed here

\author{Murray Stokely}
\title{HistogramTools \Sexpr{ht.version}: Quick Reference Guide}

% start right flush section
% redefine maketitle
%   \let\myMaketitle\maketitle
\renewcommand\maketitle{%
 \begin{center}
%  \framebox[4in]{\bf
   {\bf
   {\Large HistogramTools \Sexpr{ht.version} \par}
   {\Large Quick Reference Guide \par}
   Murray Stokely \hspace{1cm} \today \par
  }
  \mbox{\rule{\columnwidth}{0.5pt}\par}
 \end{center}
}

\begin{document}
\maketitle
\thispagestyle{empty}

\paragraph{Histogram Manipulation}

This package includes a number of basic functions for subsetting, trimming,
merging, adding, and otherwise manipulating basic R histogram objects.

<<echo=TRUE, eval=FALSE>>=
h <- hist(runif(100, 0, 100),
          breaks=seq(from=0,to=200,by=5))
plot(TrimHistogram(h))
plot(SubsetHistogram(h, maxbreak=70))
plot(MergeBuckets(h, adj.buckets=2))
@

<<echo=FALSE, print=FALSE, eval=TRUE>>=
h <- hist(runif(100, 0, 100),
          breaks=seq(from=0,to=200,by=5), plot=F)
@

<<exhist,fig=TRUE,echo=FALSE,include=FALSE>>=
# top, left, bottom, right
old.mar <- par(mar=c(3,4,1,1))
par(mfrow=c(2,2))
plot(h, main="Histogram h")
plot(TrimHistogram(h), main="TrimHistogram(h)")
plot(SubsetHistogram(h, max=70), main="SubsetHistogram(h, max=70)")
plot(MergeBuckets(h, 4), main="MergeBuckets(h, 4)")
par(mar=old.mar)
@ 
\vspace{-.3cm}

\begin{figure}[h]
\begin{center}
\includegraphics[width=3.4in,height=3.4in]{HistogramTools-quickref-exhist}
\end{center}
\label{fig:exhist}
\end{figure}

\vspace{-.3cm}

\paragraph{Information Loss}

The introduction of binning a dataset into a histogram introduces
information loss.  The package provides standard Histogram distance
measures as well as distance functions on the possibile ECDFs that
could have been constructed from the original data: the Kolmogorov-Smirnov Distance of the Cumulative
Curves (KSDCC) and Earth Mover's Distance of the Cumulative Curves
(EMDCC).  The plots here show a
visual representation of the returned value. EMDCC is the area of the
yellow boxes and KSDCC is the distance of the red arrow.

<<errorhist,fig=TRUE,echo=TRUE,include=FALSE,width=8,height=4>>=
par(mfrow=c(1,2), par(mar=c(5,4,4,0)+0.1))
PlotEMDCC(h)
PlotKSDCC(h)
EMDCC(h)
KSDCC(h)
@

\begin{figure}[h]
\begin{center}
\includegraphics[width=4in,height=2in]{HistogramTools-quickref-errorhist}
\end{center}
\label{fig:errorhist}
\end{figure}

\paragraph{Serialize a Histogram}

This package includes functions for reading and writing Histograms
from other tools.  Most notably, it can encode or decode any arbitrary
R histogram into a portable protocol buffer format to send to other
programs written in other languages.

% keep.source=T
% invisible(cat(paste(readLines(system.file("proto/histogram.proto",
%                                package="HistogramTools")), "\n")))
%@

<<echo=T,print=F,eval=F,keep.source=T>>=
hist.msg <- as.Message(h)
length(hist.msg$serialize(NULL))
@
<<echo=F,print=T,eval=T>>=
if(require(RProtoBuf)) {
  hist.msg <- as.Message(h)
  length(hist.msg$serialize(NULL))
}
@
<<echo=FALSE,print=FALSE>>=
par(oldpar)
options(oldoptions)
@

\paragraph{Common HistogramTools Functions}

\begin{center}
\begin{small}
\begin{tabular}[t]{@{\hspace{2mm}}l@{\hspace{2mm}}p{6.5cm}}
\hline
\multicolumn{2}{l}{Bin Manipulation}\\
\hline
\texttt{TrimHistogram} & Remove empty consecutive buckets from ends\\
\texttt{AddHistograms} & Aggregate two or more histograms\\
\texttt{MergeBuckets} & Merge adjacent bucket boundaries\\
\texttt{SubsetHistogram}  & Return histogram with subset of buckets\\
\texttt{IntersectHistograms} & Return a intersection of two histograms\\
\texttt{ScaleHistogram} & Scale the counts of a histogram by a factor\\
\hline
\multicolumn{2}{l}{Quantiles and Empirical CDFs}\\
\hline
\texttt{HistToEcdf} & Return the ECDF of histogram \\
\texttt{Count}  & Return the number of data points in hist\\
\texttt{ApproxMean}  & Return an approximate mean of the binned data\\
\texttt{ApproxQuantile}  & Return an approximate quantile of the binned data\\
\hline
\multicolumn{2}{l}{Distance Measures of Two Histograms}\\
\hline
\texttt{minkowski.dist} & The Minkowski distance of order $p$.\\
\texttt{intersect.dist} & The intersection distance.\\
\texttt{kl.divergence} & Kullback-Leibler Divergence.\\
\texttt{jeffrey.divergence} & Jeffrey Divergence.\\
\hline
\multicolumn{2}{l}{Binned CDF Distance Measures}\\
\hline
\texttt{PlotKSDCC}  & Plot ECDF with annotation at point of KS
distance of the cumulative curves\\
\texttt{PlotEMDCC}  & Plot ECDF with annotation showing EMD of the cumulative curves\\
\texttt{KSDCC}  & Return the Kolmogorov-Smirnov distance of the cumulative
curves (btwn 0 and 1)\\
\texttt{EMDCC}  & Return the Earth Mover's distance of the cumulative
curves (btwn 0 and 1)\\
\end{tabular}
\begin{tabular}[t]{@{\hspace{2mm}}l@{\hspace{2mm}}p{6.5cm}}
\hline
\multicolumn{2}{l}{Misc}\\
\hline
\texttt{PlotLog2ByteEcdf} & Plot ECDF of hist with power of two bucket
boundaries\\
\scriptsize{\texttt{PlotLogTimeDurationEcdf}} & Plot ECDF of hist with log-scaled
time duration bucket boundaries\\
\texttt{as.histogram} & Parse a HistogramState protocol buffer and return an R histogram\\
\texttt{as.Message}  & Serialize an R histogram as a HistogramState protocol buffer\\
\tiny{\texttt{ReadHistogramsFromDtraceOutputFile}} & Read histograms
from DTrace output\\
\hline
\end{tabular}
\end{small}
\end{center}
\end{document}

\documentclass{article}
\usepackage{amsfonts}
% TODO(mstokely): Can use a larger title here with spaces and such.
%\VignetteIndexEntry{HistogramTools-Intro}

%% JSS stuff we can remove for JSS version.
\usepackage[authoryear,round,longnamesfirst]{natbib}

\bibpunct{(}{)}{;}{a}{}{,}
\bibliographystyle{jss}
%% page layout
\topmargin 0pt
\textheight 46\baselineskip
\advance\textheight by \topskip
\oddsidemargin 0.1in
\evensidemargin 0.15in
\marginparwidth 1in
\oddsidemargin 0.125in
\evensidemargin 0.125in
\marginparwidth 0.75in
\textwidth 6.125in
%% paragraphs
\setlength{\parskip}{0.7ex plus0.1ex minus0.1ex}
\setlength{\parindent}{0em}

% The \cite command functions as follows:
%   \citet{key} ==>>                Jones et al. (1990)
%   \citet*{key} ==>>               Jones, Baker, and Smith (1990)
%   \citep{key} ==>>                (Jones et al., 1990)
%   \citep*{key} ==>>               (Jones, Baker, and Smith, 1990)
%   \citep[chap. 2]{key} ==>>       (Jones et al., 1990, chap. 2)
%   \citep[e.g.][]{key} ==>>        (e.g. Jones et al., 1990)
%   \citep[e.g.][p. 32]{key} ==>>   (e.g. Jones et al., p. 32)
%   \citeauthor{key} ==>>           Jones et al.
%   \citeauthor*{key} ==>>          Jones, Baker, and Smith
%   \citeyear{key} ==>>             1990

\newcommand{\keywords}[1]{\textbf{Keywords: }#1}
\newcommand{\code}[1]{\texttt{#1}}
\newcommand{\pkg}[1]{\textbf{#1}}
\usepackage{Sweave}
\usepackage{listings}             % Include the listings-package
\usepackage{url}
\usepackage{graphicx}

<<echo=FALSE,print=FALSE>>=
library("HistogramTools")
oldoptions <- options("width"=65)
oldpar <- par(no.readonly = TRUE)
set.seed(0)
ht.version <- packageDescription("HistogramTools")$Version
prettyDate <- format(Sys.Date(), "%B %e, %Y")
@
% closing $ needed here


%% almost as usual
\author{Murray Stokely}
\title{HistogramTools for Distributions of Large Data Sets}
\date{Version \Sexpr{ht.version} as of \Sexpr{prettyDate}}
\begin{document}

\maketitle

\abstract{
  \noindent
  Histograms are a common graphical representation of the distribution
  of a data set.  They are particularly useful for collecting very
  large data sets into a binned form for easier data storage and
  analysis.  The \pkg{HistogramTools} R package augments the
  built-in support for histograms with a number of methods that are
  useful for analyzing large data sets.  Specifically, methods are
  included for
  serializing histograms into a compact Protocol Buffer representation
  for sharing between distributed tasks, functions for
  manipulating the resulting aggregate histograms, and functions for
  measuring and visualizing the information loss associated with
  histogram representations of a data set.\\
\vspace{1ex}

\noindent
\keywords{histograms, distance, non-parametric, metric, map-reduce}
}
% \Keywords{histograms, distributions, R, mapreduce, protocol buffers, RProtoBuf}
% \Plainkeywords{histograms, distributions, R, mapreduce, protocol
%  buffers, RProtoBuf} %% without formatting.
%% at least one keyword must be supplied

%% publication information
%% NOTE: Typically, this can be left commented and will be filled out by the technical editor
%% \Volume{50}
%% \Issue{9}
%% \Month{June}
%% \Year{2012}
%% \Submitdate{2012-06-04}
%% \Acceptdate{2012-06-04}

%% The address of (at least) one author should be given
%% in the following format:

%\Address{
%  Murray Stokely\\
%  Google, Inc.\\
%  1600 Amphitheatre Parkway\\
%  Mountain View, CA 94043\\
%  E-mail: \email{mstokely@google.com}\\
%  URL: \url{http://research.google.com/pubs/MurrayStokely.html}
%  }
%
%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\tableofcontents

\section{Introduction}

Histograms have been used for over a century
\citep{pearson1895contributions} as a compact graphical representation
of a distribution of data.  Support for generating histograms is
included in almost all statistical software, including R.  However,
the growth in large-scale data analysis in R with the MapReduce
\citep{dean2008mapreduce} paradigm has highlighted the need for some
extensions to the histogram functionality in R\citep{r} for the
collection, transmission, and manipulation of larged binned data sets.

% TODO(mstokely): Also cite the streaming algorithm work?
Much previous work on histograms
\citep{sturges1926choice,scott1979optimal} involves identifying ideal
breakpoints for visualizing a data set.  Our context is different; we
use histograms as compact representations in a large MapReduce
environment, and need to merge histograms from subsets of the data to
obtain a histogram for the whole data set.  In this case, the
challenges are engineering challenges, rather than visualization challenges.
For example, how do we efficiently store large numbers of histograms
generated frequently by real-time monitoring systems of many thousands
of computers?  How can we aggregate histograms generated by different
tasks in a large scale computation?  If we chose very granular bucket
boundaries for our initial data collection pass, how can we then
reshape the bucket boundaries to be more relevant to the analysis
questions at hand?

% TODO(mstokely): Reference and cite ``Improved Histograms for
% Selectivity Estimation of Range Predicates'' which is a great survey
% of different types of histograms from the database community.

% [cite R ?hist algo] but in the parallell
% context each histogram must share the same breakpoints, even if they
% are not the optimal ones for the specific data subset any particular
% routine is accessing.  If we hope to merge the resulting histograms
% into a meaningful metric of the full data set.

% Histograms are increasingly used in leage scale distributed systems
% research.  Especially with the MapReduce paradigm where many
% thousands of tasks may analyze a big data set and collect
% distributions of interest Examples from search clusters, distributed
% filesystems, etc. [cite]

\section{Histogram Bin Manipulation}

\subsection{Trimming Empty Buckets from the Tails}

When generating histograms with a large number of fine-grained
bucket boundaries, the resulting histograms may have a large
number of empty consecutive buckets on the left or right side of the
histogram.  The \code{TrimHistogram} function can be used to remove
them, as illustrated in Figure~\ref{fig:trimhist}.

<<echo=TRUE,print=FALSE>>=
hist.1 <- hist(runif(100,min=2,max=4), breaks=seq(0,6,by=.2), plot=FALSE)
hist.trimmed <- TrimHistogram(hist.1)
@

<<echo=TRUE,print=TRUE>>=
length(hist.1$counts)
sum(hist.1$counts)
length(hist.trimmed$counts)
sum(hist.trimmed$counts)
@

<<trimhist,fig=TRUE,echo=TRUE,include=FALSE,width=8,height=4>>=
par(mfrow=c(1,2))
plot(hist.1)
plot(TrimHistogram(hist.1), main="Trimmed Histogram")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=5in,height=2.5in]{HistogramTools-trimhist}
\end{center}
\caption{Effect of the \code{TrimHistogram} function.}
\label{fig:trimhist}
\end{figure}

\subsection{Adding/Merging Histograms}

If histograms (for different data sets) have the same bucket
boundaries, it is possible to add them together to obtain the
histogram for the combined data set by aggregating the counts values
with the \code{AddHistograms} function illustrated in
Figure~\ref{fig:mergehist}.

<<echo=TRUE,print=FALSE>>=
hist.1 <- hist(c(1,2,3,4), plot=FALSE)
hist.2 <- hist(c(1,2,2,4), plot=FALSE)
hist.sum <- AddHistograms(hist.1, hist.2)
@

<<mergehist,fig=TRUE,echo=FALSE,include=FALSE,width=8,height=4>>=
par(mfrow=c(1,3))
plot(hist.1)
plot(hist.2)
plot(hist.sum,main="Aggregated Histogram")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=5in,height=2.5in]{HistogramTools-mergehist}
\end{center}
\caption{Effect of the \code{AddHistograms} function.}
\label{fig:mergehist}
\end{figure}

\code{AddHistograms} accepts an arbitrary number of histogram objects
to aggregate as long as they have the same bucket boundaries.

<<echo=TRUE,print=FALSE>>=
  hist.1 <- hist(c(1,2,3), breaks=0:9, plot=FALSE)
  hist.2 <- hist(c(1,2,3), breaks=0:9, plot=FALSE)
  hist.3 <- hist(c(4,5,6), breaks=0:9, plot=FALSE)
  hist.sum <- AddHistograms(hist.1, hist.2, hist.3)
  hist.sum
@

\subsection{Merging Buckets}

We may want a version of a histogram with fewer buckets, to save
storage or to produce better plots.  The \code{MergeBuckets} function takes
a histogram and a parameter for the number of adjacent buckets to
merge together and returns a new histogram with different bucket
boundaries, as illustrated in Figure~\ref{fig:downsamplehist}.

<<echo=TRUE,print=FALSE>>=
overbinned <- hist(c(rexp(100), 1+rexp(100)), breaks=seq(0, 10, by=.01), plot=FALSE)
better.hist <- MergeBuckets(overbinned, adj=30)
@

<<downsamplehist,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,width=8,height=4>>=
par(mfrow=c(1,2))
plot(overbinned)
plot(better.hist)
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=3.3in,height=2.5in]{HistogramTools-downsamplehist}
\end{center}
\caption{Effect of the \code{MergeBuckets} function.}
\label{fig:downsamplehist}
\end{figure}

\subsection{Subsetting Histograms}

% If, say you are only interested in part of a distribution, for
% example for performance measurements the requests that had a latency
% of greater than X seconds only.  Then the SubsetHistogram()
% functions can help manipulate the histograms to zoom in on an area
% of interest for additional plotting.

The \code{SubsetHistogram} function takes a histogram and a new
minimum and maximum bucket boundary and returns a new histogram with a
subset of the buckets, as illustrated in Figure~\ref{fig:subsethist}.

% TODO(mstokely): Add reference to iceberg queries, database work in
% this area.

<<echo=TRUE,print=FALSE>>=
hist.1 <- hist(runif(100, min=0, max=10), breaks=seq(from=0, to=10, by=.5), plot=FALSE)
hist.2 <- SubsetHistogram(hist.1, minbreak=2, maxbreak=6)
@

<<subsethist,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,width=5.3,height=4>>=
par(mfrow=c(1,2))
plot(hist.1, main="hist.1")
plot(hist.2, main="hist.2")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=3.3in,height=2.5in]{HistogramTools-subsethist}
\end{center}
\caption{Effect of the \code{SubsetHistogram} function.}
\label{fig:subsethist}
\end{figure}

\subsection{Intersecting Histograms}

The \code{IntersectHistograms} function takes two histograms with
identical bucket boundaries and returns a histogram of the
intersection of the two.  Each bucket of the returned histogram
contains the minimum of the equivalent buckets in the two provided
histograms.

<<echo=TRUE,print=FALSE>>=
hist.1 <- hist(runif(100))
hist.2 <- hist(runif(100))
hist.3 <- IntersectHistograms(hist.1, hist.2)
@

<<intersecthist,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,width=5.3,height=4>>=
par(mfrow=c(1,3))
plot(hist.1, main="hist.1")
plot(hist.2, main="hist.2")
plot(hist.3, main="hist.3")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=3.3in,height=2.5in]{HistogramTools-intersecthist}
\end{center}
\caption{Effect of the \code{IntersectHistograms} function.}
\label{fig:intersecthist}
\end{figure}

\subsection{Scaling Histograms}

The \code{ScaleHistogram} function takes a histogram and a numeric
value to scale each bucket bound by.  This can be used, e.g.\ to
normalize the histogram area to a desired value, as illustrated in
Figure~\ref{fig:scalehist}.

<<echo=TRUE,print=FALSE>>=
hist.2 <- ScaleHistogram(hist.1, 1/sum(hist.1$counts))
@

<<scalehist,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,width=5.3,height=4>>=
par(mfrow=c(1,2))
plot(hist.1, main="hist.1")
plot(hist.2, main="hist.2")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=3.3in,height=2.5in]{HistogramTools-scalehist}
\end{center}
\caption{Effect of the \code{ScaleHistogram} function.}
\label{fig:scalehist}
\end{figure}

\section{Histogram Distance Measures}

This package provides a number of metrics for computing a distance
measure for two histograms.  At the moment, only bin-by-bin similarity
measures are supported meaning that the two histograms must have
exactly the same bucket boundaries.  The attributes of the different
distance measures are described in \citep{rubner2000earth}.

\subsection{Minkowski Distance}

The Minkowski distance of order $p$ between two histograms can be
computed with the \code{minkowski.dist} function.

<<echo=TRUE,print=FALSE>>=
h1 <- hist(runif(100), plot=FALSE)
h2 <- hist(runif(100), plot=FALSE)

minkowski.dist(h1, h2, 1)
minkowski.dist(h1, h2, 2)
minkowski.dist(h1, h2, 3)

# Verify the implementation:
p <- 3
#dist(t(matrix(c(h1$counts, h2$counts), nrow=2)), "minkowski", p=p)
# Or, alternatively:
(sum(abs(h1$counts - h2$counts)^p))^(1/p)
@

\subsection{Histogram Intersection Distance}

The histogram intersection distance \citep{swain1991color} between two
histograms can be computed with the \code{intersect.dist} function.

<<echo=TRUE,print=FALSE>>=
intersect.dist(h1, h2)
@

If histograms \code{h1} and \code{h2} do not contain the
same number of counts, then this metric will not be symmetric.

\subsection{Kullback-Leibler Divergence}

The Kullback-Leibler Divergence \citep{kullback1997information}
between two histograms can be computed with the \code{kl.divergence}
function.

<<echo=TRUE,print=FALSE>>=
kl.divergence(h1, h2)
@

\subsection{Jeffrey Divergence}

The \code{jeffrey.divergence} function computes the Jeffrey
divergence between two histograms \citep{puzicha1997non}.

<<echo=TRUE,print=FALSE>>=
jeffrey.divergence(h1, h2)
@

\section{Quantiles and Cumulative Distribution Functions}

When histograms are used as a binned data storage mechanism to reduce
data storage cost, information about the underlying distribution is
lost.  We can however approximate the quantiles and cumulative
distribution function for the underying distribution from the
histogram.

The \code{Count}, \code{ApproxMean}, and \code{ApproxQuantile}
functions are meant to help with this, but note that they will only be
accurate with very granular histogram buckets.  They would rarely be
appropriate with histogram buckets chosen by the default algorithm in
R.

<<echo=TRUE>>=
hist <- hist(c(1,2,3), breaks=c(0,1,2,3,4,5,6,7,8,9), plot=FALSE)
@
<<echo=TRUE,print=TRUE>>=
Count(hist)
ApproxMean(hist)
ApproxQuantile(hist, .5)
ApproxQuantile(hist, c(.05, .95))
@

The \code{HistToEcdf} function takes a histogram and returns an
empirical distribution function similar to what is returned by the
\code{ecdf} function on a distribution.

<<execdf,fig=TRUE,include=FALSE,echo=TRUE,height=4,width=8>>=
h <- hist(runif(100), plot=FALSE)
e <- HistToEcdf(h)
e(.5)
par(mfrow=c(1,2))
plot(h)
plot(HistToEcdf(h))
par(mfrow=c(1,1))
@

\begin{figure}[h]
\begin{center}
\includegraphics[width=6in,height=3in]{HistogramTools-execdf}
\end{center}
\caption{Histogram and CDF Created with HistToEcdf}
\label{fig:excdf}
\end{figure}

\section{Error estimates in CDFs approximated from histograms}

When constructing cumulative distribution functions from binned
histogram data sets there will usually be some amount of
information loss.  We can however come up with an upper bound
for the error by looking at two extreme cases.  For a given histogram
$h$ with bucket counts $C_i$ for $1 \le i \le n$ and left-closed bucket boundaries
$B_i$ for $1 \le i \le n+1$, we construct two data sets.  Let $X$ be
the (unknown) underlying data set for which we now only have the
binned representation $h$.  Let $X_{\rm{min}}$ be the data set constructed
by assuming the data points in each bucket of the histogram are all
equal to the left bucket boundary.  Let $X_{\rm{max}}$ be the data
set constructed by assuming the data points in each bucket of the
histogram are at the right bucket boundary. Then
%histogram are all infinitesimally close to the right bucket boundary. Then
$F_X$ is the true empirical CDF of the underlying data, 
% $F(X_b)$ is any estimate of the empirical CDF based on the binned data, 
and
$F_{X_{\rm{min}}}(x) \ge F_X(x) \ge F_{X_{\rm{max}}}(x)$. 

%If $F(x)$ is the true empirical CDF of the underying data, and
%$F_b(x)$ is any estimate of the empirical CDF based on the binned
%data, then we can compute an error estimate by integrating the
%difference between the largest and smallest CDFs that could be
%represented by the binned data.  

% TODO(mstokely): Technically one of these is a limit, plus epsilon
\begin{displaymath}
X_{\rm{min}} = \left ( (B_i)_{k=1}^{C_i} : 1 \le i \le n \right ) \\
X_{\rm{max}} = \left ( (B_{i+1})_{k=1}^{C_i} : 1 \le i \le n \right )
\end{displaymath}
% x1 <- rep(head(h$breaks, -1), h$counts)
% x2 <- rep(tail(h$breaks, -1), h$counts)

The package provides two different distance metrics to measure the
difference between empirical cumulative distribution functions
$F_{X_{\rm{min}}}$ and $F_{X_{\rm{max}}}$.  These distances serve as
upper-bounds for the amount of error between the true empirical
distribution function $F_X$ of the unbinned data and an ECDF
calculated from the binned data.

<<echo=FALSE,print=FALSE>>=
PlotAll <- function(x, h) {
  plot(x, main="x")
  plot(h)
  PlotKSDCC(h, 0.3)
  PlotEMDCC(h)
}
@

\subsection{Kolmogorov-Smirnov Distance of the Cumulative Curves}

The first metric provided by the package is the two-sample
Kolmogorov-Smirnov distance between $X_{\rm{min}}$ and $X_{\rm{max}}$.
In other words, it the largest possible distance between cumulative
distribution functions that could be represented by the binned data.
This metric is more formally defined as

\begin{displaymath}
\sup_{x} \left | F_{X_{\rm{max}}}(x) - F_{X_{\rm{min}}}(x) \right |
\end{displaymath}

This function is also occasionally called the maximum displacement of
the cumulative curves (MDCC).

<<echo=TRUE,print=FALSE>>=
x <- rexp(1000)
h <- hist(x, breaks=c(0,1,2,3,4,8,16,32), plot=FALSE)
x.min <- rep(head(h$breaks, -1), h$counts)
x.max <- rep(tail(h$breaks, -1), h$counts)
ks.test(x.min, x.max, exact=F)
KSDCC(h)
@

The \code{KSDCC} function accepts a histogram, generates the largest
and smallest empirical cumulative distribution functions that could be
represented by that histogram, and then calculates the
Kolmogorov-Smirnov distance between the two CDFs.  This measure can be
used in cases where expanding the binned data into \code{x.min} and
\code{x.max} explicitly to calculate distances using
e.g.\ \code{ks.test} directly would not be feasible.
Figure~\ref{fig:KSDCC} illustrates geometrically what value is being
returned.

<<hist1mdcc,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,height=4,width=8>>=
par(mfrow=c(2,3))

x <- rexp(100)
h1 <- hist(x, plot=FALSE)
h2 <- hist(x, breaks=seq(0,round(max(x) + 1),by=0.1), plot=FALSE)

plot(sort(x), main="sort(x)")
plot(h1)
PlotKSDCC(h1, 0.2, main="CDF with KSDCC")

plot(sort(x), main="sort(x)")
plot(h2)
PlotKSDCC(h2, 0.2, main="CDF with KSDCC")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=6in,height=3in]{HistogramTools-hist1mdcc}
\end{center}
\caption{Sorted raw data (column 1), Histograms (column 2), CDF with
  KSDCC (column 3)}
\label{fig:KSDCC}
\end{figure}

\subsection{Earth Mover's Distance of the Cumulative Curves}
% The histograms above were generated using the default computed
%breakpoints of R, which uses a modified algorithm from
%\cite{sturges1926choice}.  However, for our actual data analysis tasks
%we generate our own bucket widths in advance so that all of our
%histograms have comparable and consistent bucket boundaries.  For the
%same distribution, we obviously have control over the histogram bins,
%and using more fine-grained bins produces a more accurate
%representation of the underlying distribution.

% TODO kind of like iceberg histograms, but not quite. there are
% references from the database community for what we do and why.

%A natural question is, are we using a good initial choice of buckets?
%Which of the 100,000 histograms that we generated last week had the
%greatest potential error, and how might we change the bucketing to
%reduce that error?
%
% subsubsection KS
%
%Mean Square Error measures the accuracy of an estimator of f in a single point, MISE Mean Integrated Squared Error is the global metric.  But we don't know f for the underlying distribution, since we only have the histogram, so we can't compute these metrics, right?
%
%If $F(x)$ is the true empirical CDF of the underying data, and
%$F_b(x)$ is any estimate of the empirical CDF based on the binned
%data, then we can compute an error estimate by integrating the
%difference between the largest and smallest CDFs that could be
%represented by the binned data.
%
% we can use an integrated version of the Kolmogorov-Smirnov
% distance to compute the error due to our binning.

The ``Earth Mover's Distance'' is like the Kolmogorov-Smirnof
statistic, but uses an integral to capture the difference across all
points of the curve rather than just the maximum difference.  This is
also known as Mallows distance, or Wasserstein distance with $p=1$.

The value of this metric for our histogram $h$ is
% We remove the \sup because we defined F_max and F_min above.
% \sup_{F_b,F}
\begin{displaymath}
\int_{\mathbb{R}} |F_{X_{\rm{max}}}(x) - F_{X_{\rm{min}}}(x)|dx,
\end{displaymath}

Figure~\ref{fig:EMDCC} shows the same e.c.d.f of the binned data
represented in the previous section, but with the yellow boxes
representing the range of possible values for any real e.c.d.f. having
the same binned representation.  For any distribution $X$ with the
binned representation in $h$, the e.c.d.f $F(X)$ will pass only
through the yellow boxes.  The area of the yellow boxes is the Earth
Mover's Distance.

<<hist1emdcc,fig=TRUE,echo=FALSE,print=FALSE,include=FALSE,height=4,width=8>>=
par(mfrow=c(2,3))
plot(sort(x), main="sort(x)")
plot(h1)
PlotEMDCC(h1, main="CDF with EMDCC")

plot(sort(x), main="sort(x)")
plot(h2)
PlotEMDCC(h2, main="CDF with EMDCC")
@

\begin{figure}[h!]
\begin{center}
\includegraphics[width=6in,height=3in]{HistogramTools-hist1emdcc}
\end{center}
\caption{Sorted raw data (column 1), Histograms (column 2), CDF with
  EMDCC (column 3)}
\label{fig:EMDCC}
\end{figure}

<<echo=TRUE>>=
x <- rexp(100)
h1 <- hist(x, plot=FALSE)
h2 <- hist(x, breaks=seq(0,round(max(x) + 1),by=0.1), plot=FALSE)
KSDCC(h1)
KSDCC(h2)
EMDCC(h1)
EMDCC(h2)
@

So, using this metric, the second lower example with more granular
histogram bins produces an ECDF with reduced worst case error bounds
compared to the one with default buckets, as expected.

%\begin{figure}[h!]
%\begin{center}
%\includegraphics[width=5in,height=2.5in]{HistogramTools-downsamplehist}
%\end{center}
%\caption{Effect of the \code{MergeBuckets} function.}
%\label{fig:downsamplehist}
%\end{figure}

% TODO
% \section{Extensions}
%\subsection{Exemplar Histograms}
% TODO
%

%Sharing Histograms Between Tools
%In a big data analysis task, we may combine many different tools and languages.  For example, high-performance C++ or Java code might process millions of records to generate histograms and then serialize them (using e.g. Protocol buffers or Thrift) to a data store.
%Other code in Python or R may analyze, merge, clean the resulting outputs.  Finally, a front-end dashboard may read in a JSON representation of the cleaned histograms from the datastore into an interactive Javascript web isualization (sing e.g. D3 (\cite{bostock2011d3}) or Gviz)
%Implementation details:
%
%- Benchmarks of Merge operation
%Benchmarks
%Compare size of R serialized histograms and RProtoBuf serialized histograms.
%%
%code snippet:
%
%Table:  columns:  serialized size, serialized time (ms)
%rows:  R serialize, Rprotobuf naive implementation, RProtobuf C++ optimized implementation


%TODO Table example performance analysis.
% label=tab1,echo=FALSE,results=tex>>=
%require(xtable)
%foo <- data.frame(a=c(1,2,3,4),b=c(5,6,7,8))
%print(xtable(foo, caption="Example Caption", center="centering", file="", label="tab:one",floating=FALSE))
%@
%
%Now we have an example reference to Table\ref{tab:one}.
\section{Visualization}

\subsection{Average Shifted Histograms}

Average shifted histograms are a simple device for taking a collection
of $m$ histograms each with uniform bin width $h$, but with bin
origins offset/shifted \citep{scott2009multivariate}.

Given the focus of this package on large data sets, a HistToASH
function is provided to produce the average shifted histogram from a
single histogram assuming the underlying dataset is no longer
available in unbinned form.  The next plot shows the original density histogram
of the overlaid with the average shifted histogram with smoothing
parameter 5.

<<fig=TRUE>>=
x <- runif(1000, min=0, max=100)
h <- hist(x, breaks=0:100, plot=F)

plot(h,freq=FALSE, main="Histogram of x with ASH superimposed in red")
# Superimpose the Average Shifted Histogram on top of the original.
lines(HistToASH(h), col="red")
@

\subsection{Log-scale Histograms}

Many histograms encountered in databases, distributed systems, and
other areas of computer science use log-scaled bucket boundaries
and may still contain counts that vary exponentially.

Examples of such data sets include the size or age of files stored, or
the latency enountered by read requests.  Such histograms can be read
into R using the methods of this package, but the default plotting
functionality is not very useful.

For example, Figure~\ref{fig:logloghist} shows the default plot output
for the histogram of read sizes observed when building a FreeBSD
kernel.  Neither the density histogram (left) nor the frequency
histogram (middle) make it easy to understand the distribution.  In
contract, the log ECDF produced by the \code{PlotLog2ByteEcdf}
function makes it easy to see that about 20\% of the reads were of 64
bytes or smaller, and that the median read size was well under a
kilobyte.

<<logloghist,fig=TRUE,include=FALSE,echo=FALSE,height=4,width=8>>=
par(mfrow=c(1,3))
filename <- system.file("extdata/buildkernel-readsize-dtrace.txt",
                        package="HistogramTools")
dtrace.hists <- ReadHistogramsFromDtraceOutputFile(filename)
plot(dtrace.hists[["TOTAL"]], main="", freq=FALSE)
plot(dtrace.hists[["TOTAL"]], main="", freq=TRUE)
PlotLog2ByteEcdf(dtrace.hists[["TOTAL"]])
@

\begin{figure}[h]
\begin{center}
\includegraphics[width=5in,height=2.5in]{HistogramTools-logloghist}
\end{center}
\caption{Example Log Log Histogram Data}
\label{fig:logloghist}
\end{figure}


\section{Efficient Representations of Histograms}

Consider an example histogram of 100 random data points.
Figure~\ref{fig:exhist} shows the graphical representation and list
structure of R histogram objects.

<<exhist,fig=TRUE,include=FALSE,echo=TRUE>>=
myhist <- hist(runif(100))
@

\begin{figure}[h]
\begin{minipage}{.4\textwidth}
\begin{center}
\includegraphics[width=2.5in,height=2.5in]{HistogramTools-exhist}
\end{center}
%\captionof{figure}{Example Histogram}
%\label{fig:exhist}
\end{minipage}\hfill \begin{minipage}{.5\textwidth}
\begin{tiny}
<<echo=FALSE,print=TRUE>>=
myhist
@
\end{tiny}
\end{minipage}
\caption{Example Histogram}
\label{fig:exhist}
\end{figure}

This histogram compactly represents the full distribution.
Histogram objects in R are lists with \Sexpr{length(myhist)} components: breaks, counts,
density, mids, name, and equidist.

If we are working in a parallel environment and need to distribute
such a histogram to other tasks running in a compute cluster, we
need to serialize this histogram object to a binary format that can be
transferred over the network.

\subsection{Native R Serialization}

R includes a built-in serialization framework that allows one to
serialize any R object to an Rdata file.

<<echo=TRUE,print=TRUE>>=
length(serialize(myhist, NULL))
@

This works and is quite convenient if the histogram must only be
shared between tasks running the R interpreter, but it is not a very
portable format.

\subsection{Protocol Buffers}

Protocol Buffers are a flexible, efficient, automated, cross-platform
mechanism for serializing structured data \citep{Pike:2005:IDP:1239655.1239658,protobuf}.  The RProtoBuf package
\citep{rprotobuf} provides an interface for manipulating protocol
buffer objects directly within R.

Of the \Sexpr{length(myhist)} elements stored in an R histogram object, we only need to
store three in our serialization format since the others can be
re-computed.  This leads to the following simple protocol buffer
definition of the breaks, counts, and name of a histogram:

<<echo=FALSE>>=
invisible(cat(paste(readLines(system.file("proto/histogram.proto",
                                package="HistogramTools")), "\n")))
@

The package provides \code{as.Message} and \code{as.histogram} methods
for converting between R histogram objects and this protocol buffer
representation.

In addition to the added portability, the protocol buffer
representation is significantly more compact.

<<echo=FALSE,print=FALSE>>=
if(require(RProtoBuf)) {
hist.msg <- as.Message(myhist)
} else {
hist.msg <- "RProtoBuf library not available"
}
<<echo=TRUE,print=TRUE,eval=FALSE>>=
hist.msg <- as.Message(myhist)
@

Our histogram protocol buffer has a human-readable ASCII representation:

<<echo=TRUE>>=
cat(as.character(hist.msg))
@

But it is most useful when serialized to a compact binary representation:

<<echo=TRUE,print=TRUE,eval=FALSE>>=
length(hist.msg$serialize(NULL))
<<echo=F,print=T,eval=TRUE>>=
if (require(RProtoBuf)) {
  length(hist.msg$serialize(NULL))
} else {
  invisible(cat("RProtoBuf not available."))
}
@

This protocol buffer representation is not compressed by default,
however, so we can do better:

<<echo=TRUE,print=TRUE,eval=FALSE>>=
raw.bytes <- memCompress(hist.msg$serialize(NULL), "gzip")
length(raw.bytes)
<<echo=F,print=T,eval=TRUE>>=
if (require(RProtoBuf)) {
  raw.bytes <- memCompress(hist.msg$serialize(NULL), "gzip")
  length(raw.bytes)
} else {
  raw.bytes <- memCompress("Not available", "gzip")
  cat("RProtoBuf not available")
}
@

We can then send this compressed binary representation of the
histogram over a network or store it to a cross-platform data store
for later analysis by other tools.  To recreate the
original R histogram object from the serialized protocol buffer we can
use the \code{as.histogram} method.

<<echo=TRUE,print=FALSE,eval=FALSE>>=
uncompressed.bytes <- memDecompress(raw.bytes, "gzip")
new.hist.proto <- P("HistogramTools.HistogramState")$read(uncompressed.bytes)
length(uncompressed.bytes)
<<echo=FALSE,eval=TRUE>>=
uncompressed.bytes <- memDecompress(raw.bytes, "gzip")
if (require(RProtoBuf)) {
  new.hist.proto <- P("HistogramTools.HistogramState")$read(uncompressed.bytes)
  length(uncompressed.bytes)
}
@

The resulting histogram is the same as the original; it was converted
to a protocol buffer, serialized, compressed, then uncompressed,
parsed, and converted back to a histogram.

<<echo=TRUE,print=FALSE,eval=FALSE>>=
plot(myhist)
plot(as.histogram(new.hist.proto))
@

<<fig=TRUE,echo=FALSE,height=4,width=8>>=
par(mfrow=c(1,2))
plot(myhist)
if (require(RProtoBuf)) {
  plot(as.histogram(new.hist.proto))
} else {
  plot(myhist)
}
@

\section{Applications}

\subsection{Filesystem Workload Characterization with DTrace}

The DTrace framework \cite{cantrill2004dynamic} provides a scalable
method of dynamically collecting and aggregating system performance
data on Unix systems.  The \code{ReadHistogramsFromDtraceOutputFile}
Parses the text output of the DTrace command to convert the ASCII
representation of aggregate distributions into R histogram objects.

\subsection{Binning Large Data Sets with Map-Reduce}

Many large data sets in fields such as particle physics and information
processing are stored in binned or histogram form in order to reduce
the data storage requirements \citep{scott2009multivariate}.

There are two common patterns for generating histograms of large data
sets with MapReduce.  In the first method, each mapper task can
generate a histogram over a subset of the data that is has been
assigned, and then the histograms of each mapper are sent to one or
more reducer tasks to merge.

In the second method, each mapper rounds a data point to a bucket
width and outputs that bucket as a key and '1' as a value.  Reducers
then sum up all of the values with the same key and output to a data store.

In both methods, the mapper tasks must choose identical
bucket boundaries even though they are analyzing disjoint parts of the
input set that may cover different ranges, or we must implement
multiple phases.

\begin{figure}[h!]
\begin{center}
\includegraphics{histogram-mapreduce-diag1.pdf}
\end{center}
\caption{Diagram of MapReduce Histogram Generation Pattern}
\label{fig:mr-histogram-pattern1}
\end{figure}

Figure~\ref{fig:mr-histogram-pattern1} illustrates the second method
described above for histogram generation of large data sets with
MapReduce.

This package is designed to be helpful if some of the Map or Reduce
tasks are written in R, or if those components are written in other
languages and only the resulting output histograms need to be
manipulated in R.

%There are really two cookbook recipes for generating histograms of
%large data sets.  Have each mapper generate an actual histogram, in
%which case the reducer must merge them.

%Or have each mapper output round to a bucket width and output for
%every bucket width item then have the reducer sum those up.

%Why do we do the first one?  Why not the second one?

%What is the runtime difference between the two?  Is the second
%faster?  Or the first?

%TODO:
%Good diagram for paper showing MapReduce generation of histograms.  As described in Hadoop MapReduce cookbook :

% Histogram makes sense only under a continuous dimension (for example, access time and file % size). It groups the number of occurrences of some event into several groups in the dimension. % For example, in this recipe, if we take the access time from weblogs as the dimension, then we will group the access time by the hour.
%
%The following figure shows a summary of the execution. Here the mapper calculates the hour of %the day and emits the "hour of the day" and 1 as the key and value respectively. Then each %reducer receives all the occurrences of one hour of a day, and calculates the number of %occurrences:
% THIS ABOVE IS FROM :
%\url{http://my.safaribooksonline.com/book/-/9781849517287/6dot-analytics/ch06s06_html}

%\section{Applications}
%Very large data sets in Pearson's day meant more than 100 observations, but analysis of web-scale data, such as the number of unlinks in the trillions of pages on the web requires significantly larger computation resources.
%Pearson was interested in very large data sets (more than 1000)

\section{Summary}
The HistogramTools package presented in this paper has been in wide
use for the last several years to allow engineers to read distribution
data from internal data stores written in other languages.  Internal
production monitoring tools and databases, as well as the output of
many MapReduce jobs have been used.

\bibliography{refs}

<<echo=FALSE,print=FALSE>>=
par(oldpar)
options(oldoptions)
@

\end{document}
%%  LocalWords:  HistogramTools MapReduce RProtoBuf rprotobuf proto
%%  LocalWords:  readLines memCompress gzip memDecompress mfrow CDFs
%%  LocalWords:  ApproxMean ApproxQuantile PlotAll PlotKSDCC Smirnov
%%  LocalWords:  PlotEMDCC Kolmogorov MDCC rexp KSDCC EMDCC ECDF
%%  LocalWords:  TrimHistogram trimhist AddHistograms mergehist
%%  LocalWords:  AddManyHistograms MergeBuckets overbinned Subsetting
%%  LocalWords:  downsamplehist SubsetHistogram subsethist

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{HistogramDistance}
\alias{minkowski.dist}
\alias{intersect.dist}
\alias{kl.divergence}
\alias{jeffrey.divergence}
\title{Histogram Distance Measures}
\description{
The pairs of bins in two histograms with the same bucket boundaries are
compared to compute dissimilarity measures.
% TODO(mstokely): introduce non bin-by-bin measures and then add more description
% here describing the two types.
}
\usage{
minkowski.dist(h1, h2, p)
intersect.dist(h1, h2)
kl.divergence(h1, h2)
jeffrey.divergence(h1, h2)
}
\arguments{
  \item{h1,h2}{\code{"histogram"} objects (created by
    \code{\link[graphics]{hist}}) representing a binned dataset.}
  \item{p}{Order of the Minkowski distance between two histograms to
    compute.}
}
\details{
The \code{minkowski.dist} function computes the Minkowski distance of
order \code{p} between two histograms.  \code{p=1} is the Manhattan distance
and \code{p=2} is the Euclidean distance.

The \code{intersect.dist} function computes the intersection distance of
two histograms, as defined in Swain and Ballard 1991, p15.  If
histograms \code{h1} and \code{h2} do not contain the
same total of counts, then this metric will not be symmetric.

The \code{kl.divergence} function computes the Kullback-Leibler
divergence between two histograms.

The \code{jeffrey.divergence} function computes the Jeffrey
divergence between two histograms.
}
\value{
  Each function returns a single non-negative numeric value giving the
  computed distance or divergence between the two histograms.  Larger
  values correspond to histograms that are more dissimilar.
}
\references{
Rubner, Yossi, Carlo Tomasi, and Leonidas J. Guibas. "The earth mover's
distance as a metric for image retrieval." International Journal of
Computer Vision 40.2 (2000): 99-121.

Puzicha, Jan, Thomas Hofmann, and Joachim M. Buhmann. "Non-parametric
similarity measures for unsupervised texture segmentation and image
retrieval." Computer Vision and Pattern Recognition, 1997. Proceedings.,
1997 IEEE Computer Society Conference on. IEEE, 1997.

Swain, Michael J., and Dana H. Ballard. "Color indexing." International journal of computer vision 7.1 (1991): 11-32.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link{ecdf}}, and
\code{\link[graphics]{hist}}.
}
\examples{
h1 <- hist(runif(100), plot=FALSE)
h2 <- hist(runif(100), plot=FALSE)

minkowski.dist(h1, h2, 1)
minkowski.dist(h1, h2, 2)
minkowski.dist(h1, h2, 3)
intersect.dist(h1, h2)
kl.divergence(h1, h2)
jeffrey.divergence(h1, h2)
}

% Copyright 2012 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{MergeBuckets}
\alias{MergeBuckets}
\title{Merge adjacent buckets in a histogram to create a new histogram.}
\description{
Merge adjacent buckets in a histogram and return a new histogram.
}
\usage{
  MergeBuckets(x, adj.buckets=NULL, breaks=NULL, FUN=sum)
}
\arguments{
  \item{x}{A histogram object (created by \code{\link[graphics]{hist}}).}
  \item{adj.buckets}{The number of adjacent buckets to merge together.}
  \item{breaks}{If \code{adj.buckets} is equal to \code{NULL}, then this
    argument either specifies a vector giving the breakpoints between cells, or a
    single number giving the total number of cells in the new
    histogram.  The vector of new buckets must have the same range as
    the original break list.  If a single number is provided it must be
    less than \code{length(x$breaks)}.}
  \item{FUN}{The user defined function that should be run to merge the
    counts of adjacent buckets in the histogram.}
}
\details{
Many data analysis pipelines write out histogram protocol buffers with
thousands of buckets so as to be applicable in a wide range of
contexts.  This function provides a way to transform the histogram into
one with fewer buckets.
}
\value{
  An object of class \code{"histogram"} with bucket boundaries derived
  from \code{adj.buckets} or \code{breaks} and counts produced by
  applying \code{FUN} to the counts of the corresponding adjacent
  buckets in \code{x}.  The returned object covers the same range as
  \code{x} and is suitable for plotting with
  \code{\link[graphics]{plot.histogram}}.
}
\keyword{methods}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}} and
\code{\link[graphics]{hist}}.
}
\examples{
hist.1 <- hist(c(1,2,3), breaks=c(0,1,2,3,4,5,6,7,8,9), plot=FALSE)
hist.2 <- MergeBuckets(hist.1, adj.buckets=2)

hist.1
hist.2
}
\keyword{manip}
\keyword{utilities}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{ScaleHistogram}
\alias{ScaleHistogram}
\title{Scale Histogram Counts}
\description{
Scales the counts of the provided histograms by the provided factor and
returns a new histogram.
}
\usage{
ScaleHistogram(x, factor)
}
\arguments{
  \item{x}{A \code{"histogram"} object (created by
    \code{\link[graphics]{hist}}) representing a dataset summarized by binning.}
  \item{factor}{A number value to scale the bucket counts by.  Defaults
    to 1/Count(x) to normalize the sum of counts of the histogram to 1.}
}
\value{
  An object of class \code{"histogram"} with the same \code{breaks} as
  \code{x} and \code{counts} multiplied by \code{factor}; the
  \code{density} and \code{mids} components are recomputed to remain
  consistent.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}}.
}
\examples{
x <- runif(100)
h <- hist(x, plot=FALSE)
plot(ScaleHistogram(h, 10))
}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{InformationLoss}
\alias{KSDCC}
\alias{EMDCC}
\alias{PlotKSDCC}
\alias{PlotEMDCC}
\title{Information Loss Metrics for Histograms}
\description{
Computes a metric between 0 and 1 of the amount of information lost
about the underlying distribution of data for a given histogram.
}
\usage{
KSDCC(h)
EMDCC(h)
PlotKSDCC(h, arrow.size.scale=1, main=paste("KSDCC =", KSDCC(h)), \dots)
PlotEMDCC(h, main=paste("EMDCC =", EMDCC(h)), \dots)
}
\arguments{
  \item{h}{A \code{"histogram"} object (created by
    \code{\link[graphics]{hist}}) representing a pre-binned dataset on
    which we'd like to calculate the information loss due to binning.}
  \item{arrow.size.scale}{specifies a size scaling factor for the arrow
    illustrating the point of Kolmogorov-Smirnov distance between the
    two e.c.d.fs}
  \item{main}{if 'method="constant"' a number between 0 and 1 inclusive,
    indicating a compromise between left- and right-continuous
    step functions.  See ?approxfun}
  \item{\ldots}{Any other arguments to pass to \code{\link[graphics]{plot}}}
}
\details{
The \code{KSDCC} (Kolmogorov-Smirnov Distance of the Cumulative Curves)
function provides the Kolmogorov-Smirnov distance between the empirical
distribution functions of the smallest and largest datasets that could
be represented by the binned data in the provided histogram.  This
quantity is also called the Maximum Displacement of the Cumulative
Curves (MDCC) in the computer science performance evaluation community (see
references).

The \code{EMDCC} (Earth Mover's Distance of the Cumulative Curves)
function is like the Kolmogorov-Smirnov statistic, but uses an integral
to capture the difference across all points of the curve rather than
just the maximum difference.  This is also known as Mallows distance, or
Wasserstein distance with $p=1$.

The \code{PlotKSDCC} and \code{PlotEMDCC} functions take a histogram and
generate a plot showing a geometric representation of the information
loss metrics for the provided histogram.
}
\value{
  \code{KSDCC} and \code{EMDCC} each return a single numeric value
  between 0 and 1 quantifying the information loss for the supplied
  histogram.  \code{PlotKSDCC} and \code{PlotEMDCC} have no return
  value and are called for the side effect of drawing an annotated
  ECDF plot on the current graphics device.
}
\references{Douceur, John R., and William J. Bolosky. "A large-scale
  study of file-system contents." \emph{ACM SIGMETRICS Performance
  Evaluation Review} \bold{27.1} (1999): 59-70.}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link{ecdf}}, and
\code{\link[graphics]{hist}}.
}
\examples{
x <- rexp(1000)
h <- hist(x, breaks=c(0,1,2,3,4,8,16,32), plot=FALSE)
KSDCC(h)

# For small enough data sets we can construct the two extreme data sets
# that can be constructed from a histogram.  One assuming every data point
# is on the left boundary of its bucket, and another assuming every data
# point is on the right boundary of its bucket.  Our KSDCC metric for
# histograms is equivalent to the ks.test statistics for these two
# extreme data sets.

x.min <- rep(head(h$breaks, -1), h$counts)
x.max <- rep(tail(h$breaks, -1), h$counts)
ks.test(x.min, x.max, exact=FALSE)

PlotKSDCC(h)

EMDCC(h)
PlotEMDCC(h)
}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{PlotLog2ByteEcdf}
\alias{PlotLog2ByteEcdf}
\alias{PlotLogTimeDurationEcdf}
\title{Plot Binned Histogram and ECDF Data.}
\description{
Produces aesthetically pleasing ECDF plots for two common classes of
non-equiwidth histograms.  Specifically, (1) histograms with power of two
bucket boundaries commonly used in computer science for measuring
resource usage, and (2) histograms with log-scaled time duration buckets
with a range from 1 second to 10 years.
}
\usage{
PlotLog2ByteEcdf(x, xlab="Bytes (log)",
                 ylab="Cumulative Fraction", with.grid=TRUE, \dots)
PlotLogTimeDurationEcdf(x, with.grid=TRUE,
                        xlab="Age (log)",
                        ylab="Cumulative Fraction",
                        cex.lab=1.6,
                        cex.axis=1.6, \dots)
}
\arguments{
  \item{x}{A \code{"histogram"} object (created by
    \code{\link[graphics]{hist}}) representing a pre-binned dataset or
    an \code{"ecdf"} object (created by \code{\link[stats]{ecdf}} or
    \code{\link{HistToEcdf}}).}
  \item{xlab}{x-axis label for the Ecdf plot.}
  \item{ylab}{y-axis label for the Ecdf plot.}
  \item{with.grid}{Logical.  If \code{TRUE}, draw faint grid lines on the ECDF
    plot.}
  \item{cex.lab}{Graphical parameters for plot and axes.}
  \item{cex.axis}{Graphical parameters for plot and axes.}
  \item{\ldots}{Additional parameters are passed to
    \code{\link[graphics]{plot}()}.}
}
\details{
The \code{PlotLog2ByteEcdf} function takes a \code{"histogram"} or
\code{"ecdf"} which has power of 2 bucket boundaries representing bytes
and creates an Ecdf plot.

The \code{PlotLogTimeDurationEcdf} function takes a \code{"histogram"}
or \code{"ecdf"} with exponential bucket boundaries representing
seconds of age or duration and creates an Ecdf plot.
}
\value{
  No return value; both functions are called for their side effect of
  drawing an ECDF plot on the current graphics device.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}}.
\code{\link[stats]{ecdf}}.
}
\examples{
filename <- system.file("extdata/buildkernel-readsize-dtrace.txt",
                         package="HistogramTools")
dtrace.hists <- ReadHistogramsFromDtraceOutputFile(filename)
x <- SubsetHistogram(dtrace.hists[["TOTAL"]], minbreak=1)
PlotLog2ByteEcdf(x, cex.lab=1.4)

x <- rexp(100000)
x <- x*(86400*300)/diff(range(x))

n <- as.integer(1+log2(max(x)))

h <- hist(x, breaks=c(0, unique(as.integer(2^seq(from=0, to=n, by=.25)))))
PlotLogTimeDurationEcdf(h)
}

% Copyright 2011 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{AddHistograms}
\alias{AddHistograms}
\alias{.NewHistogramName}
\title{Aggregate histograms that have identical breaks.}
\description{
Aggregate histogram objects that have identical breaks.
}
\usage{
  AddHistograms(\dots, x=list(\dots), main=.NewHistogramName(x))
  .NewHistogramName(x)
}
\arguments{
  \item{\dots}{Histogram objects (created by \code{\link[graphics]{hist}}).}
  \item{x}{A list of histogram objects. If \code{x} is supplied then the
  \ldots are ignored.}
  \item{main}{A title to add to the aggregated/merged histogram.  By default, if
    two histograms are provided a title will be created that includes
    the names of the original histograms.  If more histograms are
    provided the title will simply include the number of aggregated histograms.
  }
}
\details{
This function adds the buckets of the provided histograms to return a single
aggregated histogram.

\code{.NewHistogramName} is a utility that takes the list of histogram
objects to be aggregated and returns a name for the new merged
histogram.  It is normally hidden, but can be viewed using
\code{HistogramTools:::.NewHistogramName}.
}
\value{
  \code{AddHistograms} returns an object of class \code{"histogram"}
  whose \code{breaks} match those of the inputs and whose \code{counts}
  are the elementwise sum of the counts of the supplied histograms.
  \code{.NewHistogramName} returns a single character string suitable
  for use as the \code{xname} of the merged histogram.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}} and
\code{\link[graphics]{hist}}.
}
\examples{
hist.1 <- hist(c(1,2,3,4), plot=FALSE)
hist.2 <- hist(c(1,2,2,4), plot=FALSE)
hist.sum <- AddHistograms(hist.1, hist.2)
hist.3 <- hist(c(1,2,2,4), plot=FALSE)
hist.sum <- AddHistograms(hist.1, hist.2, hist.3)
}
\keyword{manip}
\keyword{utilities}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{PreBinnedHistogram}
\alias{PreBinnedHistogram}
\title{PreBinnedHistogram}
\description{
Takes a set of already binned data represented by a vector of $n+1$
breaks and a vector of $n$ counts and returns a normal R histogram
object.
}
\usage{
PreBinnedHistogram(breaks, counts, xname="")
}
\arguments{
  \item{breaks}{A numeric vector of n+1 breakpoints for the histogram.}
  \item{counts}{A numeric vector of n counts for each bucket of the
    histogram.}
  \item{xname}{A character string with the name for this histogram.}
}
\value{
  An object of class \code{"histogram"} (a list with components
  \code{breaks}, \code{counts}, \code{density}, \code{mids}, \code{xname},
  and \code{equidist}) constructed from the supplied breaks and counts,
  suitable for plotting with \code{\link[graphics]{plot.histogram}} or for
  use with the other functions in this package.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}}.
}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{SubsetHistogram}
\alias{SubsetHistogram}
\title{Subset a histogram by removing some of the buckets.}
\description{
SubsetHistogram creates a histogram by zooming in on a portion of a
larger histogram and discarding tail buckets.
}
\usage{
  SubsetHistogram(x, minbreak=NULL, maxbreak=NULL)
}
\arguments{
  \item{x}{A histogram object (created by \code{\link[graphics]{hist}}).}
  \item{minbreak}{If non-\code{NULL}, specifies a new minimum breakpoint
for the returned histogram.  Must be one of the existing breakpoints of \code{x}.}
  \item{maxbreak}{If non-\code{NULL}, specifies a new maximum breakpoint
for the returned histogram.  Must be one of the existing breakpoints of \code{x}.}
}
\details{
This function provides a way to "zoom-in" on a histogram by setting new
minimum and maximum breakpoints and returning a histogram of only the
interior part of the distribution.  At least one of \code{minbreak} or
\code{maxbreak} should be set, otherwise the original histogram is
returned unmodified.
}
\value{
  An object of class \code{"histogram"} containing only the buckets of
  \code{x} whose boundaries lie within \code{[minbreak, maxbreak]}; the
  remaining buckets, breaks, and other components are recomputed to be
  internally consistent.
}
\keyword{methods}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}} and
\code{\link[graphics]{hist}}.
}
\examples{
hist.1 <- hist(c(1,2,3), breaks=c(0,1,2,3,4,5,6,7,8,9), plot=FALSE)
hist.2 <- SubsetHistogram(hist.1, maxbreak=6)

hist.1
hist.2
}
\keyword{manip}
\keyword{utilities}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{HistToEcdf}
\alias{HistToEcdf}
\title{Empirical Cumulative Distribution Function From a Histogram.}
\description{
Computes an approximate empirical cumulative distribution function of a
data set given a binned histogram representation of that dataset.
}
\usage{
HistToEcdf(h, method="constant", f=0, inverse=FALSE)
}
\arguments{
  \item{h}{A histogram object (created by \code{\link[graphics]{hist}}) representing a pre-binned dataset
    on which we'd like to calculate an ECDF.}
  \item{method}{specifies the interpolation method to be used in call to
    \code{\link[stats]{approxfun}()}.  Choices are \code{"linear"} or \code{"constant"}.}
  \item{f}{if \code{method="constant"} a number between 0 and 1 inclusive,
    indicating a compromise between left- and right-continuous
    step functions.  See \code{?approxfun}}
  \item{inverse}{if \code{TRUE} return the inverse Ecdf.}
}
\details{
  This function approximates the e.c.d.f. (empirical cumulative
  distribution function) of a data set given a binned
  histogram representation of that data set.
}
\value{
  A function of class \code{c("ecdf", "stepfun", "function")}, as
  returned by \code{\link[stats]{ecdf}}.  Calling it with a numeric
  vector \code{x} returns the approximate cumulative probability at
  each value of \code{x}.  If \code{inverse=TRUE} the returned function
  instead maps a probability in \code{[0,1]} to the corresponding
  approximate quantile.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link{ecdf}},
\code{\link[stats]{approxfun}}, and
\code{\link[graphics]{hist}}.
}
\examples{
h <- hist(runif(100), plot=FALSE)
plot(HistToEcdf(h))
}
\keyword{manip}
\keyword{utilities}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{PlotRelativeFrequency}
\alias{PlotRelativeFrequency}
\title{Plot Relative Frequency Histogram}
\description{
Produces a relative frequency histogram.
}
\usage{
PlotRelativeFrequency(x, ylab="Relative Frequency", \dots)
}
\arguments{
  \item{x}{A \code{"histogram"} object (created by
    \code{\link[graphics]{hist}}) representing a pre-binned dataset.}
  \item{ylab}{y-axis label for the plot.}
  \item{\dots}{Additional parameters are passed to
    \code{\link[graphics]{plot}()}.}
}
\details{
The default \code{\link[graphics]{plot.histogram}} function supports Frequency or
Density plots, but does not provide a way to produce a relative
frequency histogram.  This function plots this type of histogram.
}
\value{
  No return value; called for the side effect of drawing a relative
  frequency histogram on the current graphics device.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}},
\code{\link[graphics]{plot.histogram}}.
}
\examples{
x <- runif(100)
h <- hist(x, plot=FALSE)
PlotRelativeFrequency(h)
}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{IntersectHistograms}
\alias{IntersectHistograms}
\title{Intersect Histograms}
\description{
Takes two histograms with identical bucket boundaries and returns a
histogram of the intersection of the two.  Each bucket of the returned
histogram contains the minimum of the equivalent buckets in the two
provided histograms.
}
\usage{
IntersectHistograms(h1, h2)
}
\arguments{
  \item{h1,h2}{\code{"histogram"} objects (created by
    \code{\link[graphics]{hist}}) representing a dataset summarized by binning.}
}
\value{
  An object of class \code{"histogram"} whose \code{breaks} match those
  of the input histograms and whose \code{counts} are the elementwise
  minimum of the counts in \code{h1} and \code{h2}.
}
\references{
Swain, Michael J., and Dana H. Ballard. "Color indexing." International journal of computer vision 7.1 (1991): 11-32.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}}.
}
\examples{
h1 <- hist(runif(100), plot=FALSE)
h2 <- hist(runif(100), plot=FALSE)
plot(IntersectHistograms(h1, h2))
}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{dtracehistograms}
\alias{dtrace}
\alias{ReadHistogramsFromDtraceOutputFile}
\title{Read Histograms from text DTrace output file.}
\description{
Parses the text output of the DTrace command to convert the ASCII
representation of aggregate distributions into R histogram objects.
}
\usage{
ReadHistogramsFromDtraceOutputFile(filename)
}
\arguments{
  \item{filename}{A character vector naming a file that is the output of
    dtrace with aggregate distribution statistics in it.}
}
\details{
  The DTrace dynamic tracing framework allows users to trace
  applications and computer operating systems.  One of its common
  outputs is aggregates of a distribution (for example, read request
  sizes) that are output as a histogram.  This function takes the text
  output from a dtrace command and looks for text distribution
  representations that can be parsed into R histogram objects.
}
\value{
A list of histogram objects representing the histograms present in the
Dtrace output file.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[graphics]{hist}}.
}
\examples{
# A sample DTrace output file is bundled with the package.  In a real
# DTrace session the file would be produced by something like:
#   dtrace -n 'syscall::read:return { @[execname] = quantize(arg0); }' \
#     > /tmp/dtraceoutput
filename <- system.file("extdata/buildkernel-readsize-dtrace.txt",
                        package="HistogramTools")
read.size.hists <- ReadHistogramsFromDtraceOutputFile(filename)
plot(read.size.hists[["TOTAL"]])
}
\keyword{manip}
\keyword{utilities}
\keyword{datagen}

% Copyright 2013 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{ASH}
\alias{HistToASH}
\title{Average Shifted Histograms From a Histogram.}
\description{
Computes a univariate average shifted histogram (polynomial kernel)
given a single input histogram.
}
\usage{
HistToASH(h, m=5, kopt=c(2,2))
}
\arguments{
  \item{h}{A histogram object (created by \code{\link[graphics]{hist}})
    representing a pre-binned dataset.}
  \item{m}{optional integer smoothing parameter, passed to
    \code{\link[ash]{ash1}()}.}
  \item{kopt}{vector of length 2 specifying the kernel, passed to
    \code{\link[ash]{ash1}()}.}
}
\details{
  This function takes a histogram and uses the counts as the input to
  the \code{\link[ash]{ash1}()} function in the ash package to compute
  the average shifted histogram.
}
\value{
  A list of class \code{"ash"} as returned by \code{\link[ash]{ash1}()},
  containing components \code{x} and \code{y} giving the bin centers and
  estimated density values for the average shifted histogram, suitable
  for use with \code{\link[graphics]{plot}} or \code{\link[graphics]{lines}}.
}
\references{Scott, David W. \emph{Multivariate density estimation:
    theory, practice, and visualization.} Vol. 383. Wiley. com, 2009.}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link[ash]{ash1}}, and
\code{\link[graphics]{hist}}.
}
\examples{
x <- runif(1000, min=0, max=100)
h <- hist(x, breaks=0:100, plot=FALSE)
plot(h, freq=FALSE)

# Superimpose the Average Shifted Histogram on top of the original.
lines(HistToASH(h), col="red")
}
\keyword{nonparametric}

% Copyright 2011 Google Inc. All Rights Reserved.
% Author: mstokely@google.com (Murray Stokely)
\name{as.histogram}
\alias{as.histogram}
\alias{as.histogram.default}
\alias{as.histogram.Message}
\title{Convert histogram protocol buffers to histogram objects}
\description{This package provides a number of utility functions
useful for manipulating large histograms.  It provides a
\file{HistogramTools.HistogramState} protocol buffer representation of
the default R histogram class to allow histograms to be very concisely
serialized and shared with other systems in a distributed MapReduce
environment.  It also includes a number of utility functions for
manipulating large histograms.}

\usage{
  \method{as.histogram}{Message}(x, \dots)
}
\arguments{
  \item{x}{An RProtoBuf Message of type "HistogramTools.HistogramState"
  to convert to a histogram object.}
  \item{\dots}{Not used.}
}
\details{
  \code{as.histogram} reads the provided Protocol Buffer
  message and extracts the buckets and counts to populate into the
  standard R histogram class which can be plotted.
}
\value{
  An object of class \code{"histogram"} (a list with components
  \code{breaks}, \code{counts}, \code{density}, \code{mids}, \code{xname},
  and \code{equidist}) reconstructed from the supplied
  \code{HistogramTools.HistogramState} protocol buffer, suitable for use
  with \code{\link[graphics]{plot.histogram}} and the other functions in
  this package.
}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}},
\code{\link{as.Message}}, and
\code{\link[RProtoBuf]{RProtoBuf}}.
}
\examples{
  if (requireNamespace("RProtoBuf", quietly = TRUE)) {
  tmp.hist <- hist(c(1,2,4,43,20,33,1,1,3), plot=FALSE)
  # The default R serialization takes a fair number of bytes
  length(serialize(tmp.hist, NULL))

  # Convert to a protocol buffer representation.
  hist.msg <- as.Message(tmp.hist)

  # Which has an ASCII representation like this:
  cat(as.character(hist.msg))

  # Or can be serialized and shared with other tools much more
  # succinctly than R's built-in serialization format.
  length(hist.msg$serialize(NULL))

  # And since this isn't even compressed, we can reduce it further
  # with in-memory compression:
  length(memCompress(hist.msg$serialize(NULL)))

  # If we read in the raw.bytes from another tool
  raw.bytes <- hist.msg$serialize(NULL)

  # We can parse the raw bytes as a protocol buffer
  new.hist.proto <- RProtoBuf::P("HistogramTools.HistogramState")$read(raw.bytes)
  new.hist.proto

  # Then convert back to a native R histogram.
  new.hist <- as.histogram(new.hist.proto)

  # The new histogram and the old are identical except for xname
  }
}
\keyword{manip}
\keyword{utilities}

% Copyright 2011 Google Inc. All Rights Reserved.
% Author: mstokely@google.com (Murray Stokely)
\name{HistogramTools-package}
\alias{HistogramTools-package}
\alias{HistogramTools}
\alias{histogram}
\docType{package}
\title{HistogramTools package}

\description{This package provides a number of utility functions for
  manipulating R's native histogram objects.  The functions are focused
  on operations that are particularly useful when dealing with large
  numbers of histograms with identical buckets, such as those produced
  from distributed MapReduce computations.  This package also provides a
  \file{HistogramTools.HistogramState} protocol buffer representation of
  the default R histogram class to allow histograms to be very concisely
  serialized and shared with other systems.
}
\details{
See \code{library(help=HistogramTools)} for version number, dates,
dependencies, and a complete list of functions.

Index (possibly out of date):
\preformatted{
AddHistograms         Aggregate histogram objects that have identical breaks.
MergeBuckets          Merge adjacent buckets of a histogram.
ApproxQuantile        Approximate the quantiles of the underlying distribution.
ApproxMean            Approximate the mean of the underlying distribution.
Count                 Count of all samples in a histogram.
HistToEcdf            Approximate the ECDF of the underlying distribution.
SubsetHistogram       Subset a histogram by removing some of the buckets.
TrimHistogram         Remove empty buckets from the tails of a histogram.
ScaleHistogram        Scale histogram bucket counts by a numeric value.
PreBinnedHistogram    Generate a histogram from pre-binned data.
AshFromHist           Compute Average Shifted Histogram from a histogram.
KSDCC                 Compute maximal KS-statistic of CDFs constructed from histogram.
EMDCC                 Compute maximal Earth Mover's Distance of CDFs constructed from histogram.
PlotKSDCC             Plot the KSDCC metric and a CDF from the histogram.
PlotEMDCC             Plot the EMDCC metric and a CDF from the histogram.
PlotLog2ByteEcdf      Plot the CDF from a histogram with log2 scaled byte boundaries.
PlotLogTimeDurationEcdf Plot the CDF from a histogram with log scaled time duration boundaries.
PlotRelativeFrequency Plot a relative frequency histogram.
ReadHistogramsFromDtraceOutputFile  Read a list of Histograms from the output of the DTrace tool.
minkowski.dist        Compute the Minkowski difference between two histograms.
intersect.dist        Compute the histogram intersection distance between two histograms.
kl.divergence         Compute the Kullback-Leibler divergence between two histograms.
jeffrey.divergence    Compute the Jeffrey divergence between two histograms.
}
}
\author{
Murray Stokely <murray@stokely.org>
}
\keyword{ package }
\seealso{
\code{\link[graphics]{hist}}
}
\examples{
  if (requireNamespace("RProtoBuf", quietly = TRUE)) {
  tmp.hist <- hist(c(1,2,4,43,20,33,1,1,3), plot=FALSE)
  # The default R serialization takes a fair number of bytes
  length(serialize(tmp.hist, NULL))

  # Convert to a protocol buffer representation.
  hist.msg <- as.Message(tmp.hist)

  # Which has an ASCII representation like this:
  cat(as.character(hist.msg))

  # Or can be serialized and shared with other tools much more
  # succinctly than R's built-in serialization format.
  length(hist.msg$serialize(NULL))

  # And since this isn't even compressed, we can reduce it further
  # with in-memory compression:
  length(memCompress(hist.msg$serialize(NULL)))

  # If we read in the raw.bytes from another tool
  raw.bytes <- hist.msg$serialize(NULL)

  # We can parse the raw bytes as a protocol buffer
  new.hist.proto <- RProtoBuf::P("HistogramTools.HistogramState")$read(raw.bytes)
  new.hist.proto

  # Then convert back to a native R histogram.
  new.hist <- as.histogram(new.hist.proto)

  # The new histogram and the old are identical except for xname
  }
}

% Copyright 2012 Google Inc. All Rights Reserved.
% Author: mstokely@google.com (Murray Stokely)

\name{trimsparse}
\alias{trimsparse}
\alias{trimhistogram}
\alias{TrimHistogram}
\title{Trim the tails of a sparse histogram.}
\description{
Removes empty consecutive buckets at the tails of a histogram.
}
\usage{
TrimHistogram(x, left=TRUE, right=TRUE)
}
\arguments{
  \item{x}{A histogram object (created by \code{\link[graphics]{hist}}).}
  \item{left}{If \code{TRUE}, consecutive buckets in the left tail of the
    histogram without any elements will
    be removed from the returned histogram.}
  \item{right}{If \code{TRUE}, consecutive buckets in the right tail of the
    histogram without any elements will
    be removed from the returned histogram.}
}
\details{
Many data analysis pipelines write out histogram protocol buffers with
thousands of buckets so as to be applicable in a wide range of
contexts.  This function provides a way to transform the histogram into
one with fewer buckets by removing sparseness in the tails.
}
\value{
  An object of class \code{"histogram"} identical to \code{x} except
  with consecutive zero-count buckets removed from the requested
  tails.  If all buckets of \code{x} are empty the histogram is
  returned unchanged with a warning.
}
\keyword{methods}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}} and
\code{\link[graphics]{hist}}.
}
\examples{
hist.1 <- hist(c(1,2,3), breaks=c(0,1,2,3,4,5,6,7,8,9), plot=FALSE)
length(hist.1$counts)
sum(hist.1$counts)
hist.trimmed <- TrimHistogram(hist.1)
length(hist.trimmed$counts)
sum(hist.trimmed$counts)
}
\keyword{manip}
\keyword{utilities}

% Copyright 2012 Google Inc. All Rights Reserved.
%
% Licensed under the Apache License, Version 2.0 (the "License");
% you may not use this file except in compliance with the License.
% You may obtain a copy of the License at
%
%     http://www.apache.org/licenses/LICENSE-2.0
%
% Unless required by applicable law or agreed to in writing, software
% distributed under the License is distributed on an "AS IS" BASIS,
% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
% See the License for the specific language governing permissions and
% limitations under the License.
%
% Author: mstokely@google.com (Murray Stokely)

\name{quantile}
\alias{ApproxQuantile}
\alias{ApproxMean}
\alias{Count}
\title{Histogram Approximate Quantiles.}
\description{
Approximate the quantiles of the underlying distribution for which only
a histogram is available.
}
\usage{
ApproxQuantile(x, probs, \dots)
ApproxMean(x)
Count(x)
}
\arguments{
  \item{x}{A histogram object (created by \code{\link[graphics]{hist}}).}
  \item{probs}{Numeric vector of probabilities with values in [0,1].}
  \item{\dots}{Any other arguments to pass to \code{\link[Hmisc]{wtd.quantile}}.}
}
\details{
Many data analysis pipelines write out histogram protocol buffers with
thousands of buckets so as to be applicable in a wide range of
contexts.  This function provides a way to transform the histogram into
approximations of the quantile, median, mean, etc of the underlying
distribution.  \code{Count(x)} returns the number of
observations in the histogram.
}
\value{
  \code{Count} returns a single numeric value giving the total number
  of observations summarized by the histogram (the sum of
  \code{x$counts}).  \code{ApproxMean} returns a single numeric value
  giving an approximation of the mean of the underlying distribution
  computed as a weighted mean of the bucket midpoints.
  \code{ApproxQuantile} returns a numeric vector the same length as
  \code{probs} containing approximate quantiles of the underlying
  distribution; if \code{probs} is named the result is named
  accordingly.
}
\keyword{methods}
\author{Murray Stokely \email{murray@stokely.org}}
\seealso{
\code{\link{HistogramTools-package}} and
\code{\link[graphics]{hist}}.
}
\examples{
x <- hist(c(1,2,3), breaks=c(0,1,2,3,4,5,6,7,8,9), plot=FALSE)
Count(x)
ApproxMean(x)
ApproxQuantile(x, .5)
ApproxQuantile(x, c(.05, .95))
}
\keyword{manip}
\keyword{utilities}
